// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.13 $
#include <hk_datasource.h>

#include <hk_kdeboolean.h>
#include <hk_kdeboolean.moc>
#include <qkeycode.h>
#include <hk_form.h>
hk_kdeboolean::hk_kdeboolean(QWidget* wid,hk_form* form)
		:QCheckBox(wid),
		 hk_dsboolean(form)

{
#ifdef HK_DEBUG
hkdebug("hk_kdeboolean::hk_kdeboolean");
#endif
	QObject::connect(this,SIGNAL(clicked()),this,SLOT(slot_data_changed()));
	p_widget_specific_row_change=true;
	setEnabled(false);


}

hk_kdeboolean::~hk_kdeboolean(void)
{

}

void hk_kdeboolean::keyPressEvent( QKeyEvent * e )
{
#ifdef HK_DEBUG
hkdebug("hk_kdeboolean::keyPressEvent");
#endif

  if (e->key()==Key_Return)
  {
   if (e->state()&ControlButton)
	focusNextPrevChild(false);
   else
	focusNextPrevChild(true);

  }
  else
  {
     if (column()!=NULL) if (column()->is_readonly())return;

     QCheckBox::keyPressEvent(e);
  }
}


bool hk_kdeboolean::widget_specific_row_change(void)
{
#ifdef HK_DEBUG
hkdebug("kdeboolean::widget_specific_row_change");
#endif
	hk_column* c=column();
  p_widget_specific_row_change=true;
	if (c!=NULL)
    			{
      				setChecked(c->asbool());
    			}


 p_widget_specific_row_change=false;
  return true;

}


void hk_kdeboolean::slot_data_changed(void)
{
 	#ifdef HK_DEBUG
 	hkdebug("kdeboolean::slotDataChanged");
 	#endif
 	if (!p_widget_specific_row_change)
 	{
 	#ifdef HK_DEBUG
 	hkdebug("kdeboolean::data has changed!");
 	#endif
 	 if (column()!=NULL)
 	 {
 	#ifdef HK_DEBUG
 	hkdebug("kdeboolean::data will be updated");
 	#endif
 	   column()->set_asbool(isChecked());
 	 }
 	}

}


void hk_kdeboolean::widget_specific_enable_disable()
{
#ifdef HK_DEBUG
hkdebug("kdeboolean::widget_specific_enable_disable");
#endif
 if ((datasource()!=NULL)&&(column()!=NULL))
 {
  #ifdef HK_DEBUG
hkdebug("kdeboolean::if ((datasource()!=NULL)&&(column()!=NULL))");
#endif

 	if (datasource()->is_enabled()>0)
 	{
 	  setEnabled(true);
 	  widget_specific_row_change();
 	}
 	else setEnabled(false);
 }
 else
   {
     setEnabled(false);
     setChecked(false);
   }

/* if (p_form!=NULL) if (p_form->state()==hk_form::design)
 {
    setFocusPolicy(NoFocus);
    setEnabled(true);
  }
  else
*/
  setFocusPolicy(StrongFocus);

}

void hk_kdeboolean::resizeEvent ( QResizeEvent * event )
{
#ifdef HK_DEBUG
hkdebug("kdeboolean::resizeEvent");
#endif
  QCheckBox::resizeEvent(event);
  reposition();

}


void  hk_kdeboolean::moveEvent ( QMoveEvent * event)
{
#ifdef HK_DEBUG
hkdebug("kdeboolean::moveEvent");
#endif
    QCheckBox::moveEvent(event);
    reposition();
}

void hk_kdeboolean::reposition(void)
{
#ifdef HK_DEBUG
hkdebug("kdeboolean::reposition");
#endif
  if (p_form==NULL ||p_setcoordinates==true) return;
  p_setwidgetcoordinates=true;
    unsigned int ppx=p_form->horizontal2relativ(QCheckBox::x());
    unsigned int ppy=p_form->vertical2relativ(QCheckBox::y());
    unsigned int pph=p_form->vertical2relativ(QCheckBox::height(),p_dynamicheight);
    unsigned int ppw=p_form->horizontal2relativ(QCheckBox::width(),p_dynamicwidth);
    set_size(ppx,ppy,ppw,pph,p_dynamicwidth,p_dynamicheight);
  p_setwidgetcoordinates=false;
}


bool hk_kdeboolean::widget_specific_coordinates(uint px,uint py,uint pwidth,uint pheight)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeboolean::widget_specific_coordinates");
#endif
	setGeometry(px,py,pwidth,pheight);
	qApp->processEvents();
 return true;
}



void	hk_kdeboolean::widget_specific_label_changed(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeboolean::widget_specific_label_changed");
#endif
   if (label().size()>0)setText(label().c_str());
   else setText(hk_translate("label").c_str());
}

void hk_kdeboolean::widget_specific_font_changed(void)
{
    setFont(QFont(p_font.c_str(),p_fontsizeint));
}

void	hk_kdeboolean::widget_specific_insert_mode(void)
{
 blockSignals(true);
 setChecked(use_defaultvalue()?(raw_defaultvalue()=="%TRUE%"):false);
 blockSignals(false);
}

void hk_kdeboolean::mousePressEvent(QMouseEvent* m)
{
    if (column()!=NULL) if (column()->is_readonly()) return;
    QCheckBox::mousePressEvent(m);
}
