// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.19 $
#include <hk_datasource.h>
#include <hk_kdecombobox.h>
#include <hk_kdecombobox.moc>
#include <hk_form.h>

hk_kdecombobox::hk_kdecombobox(QWidget* wid,hk_form* form):KComboBox(true,wid),hk_dscombobox(form)
{
#ifdef HK_DEBUG
hkdebug("hk_kdecombobox::hk_kdecombobox");
//wanna_debug(true);
#endif
	QObject::connect(this,SIGNAL(activated(int)),this,SLOT(slot_data_changed(int)));
	p_widget_specific_row_change=true;
	setEditable(true);
	setAutoCompletion(true);
	setDuplicatesEnabled(false);
	setEnabled(false);

}

void hk_kdecombobox::slot_data_changed(int index)
{
#ifdef HK_DEBUG
hkdebug("kdecombobox::slotDataChanged");
#endif
// 	if (!p_widget_specific_row_change)
 	{
 	#ifdef HK_DEBUG
 	//hkdebug("kdecombobox::data has changed!");
 	#endif
 	set_selecteditemdata(index);

 	}

}
bool hk_kdecombobox::widget_specific_row_change(void)
{
#ifdef HK_DEBUG
hkdebug("kdecombobox::widget_specific_row_change");
#endif
  hk_column* c=column();
  p_widget_specific_row_change=true;
   if (c!=NULL)
    			{
      				  hk_dscombobox::widget_specific_row_change();
				  //set_actuallistitem();
      				//setText(c->asstring());
    			}



 p_widget_specific_row_change=false;
 return true;
}

void hk_kdecombobox::widget_specific_enable_disable()
{
#ifdef HK_DEBUG
hkdebug("kdecombobox::widget_specific_enable_disable");
#endif
 if ((datasource()!=NULL)&&(column()!=NULL))
 {
  #ifdef HK_DEBUG
hkdebug("kdecombobox::if ((datasource()!=NULL)&&(column()!=NULL))");
#endif

 	if (datasource()->is_enabled()>0)
	  {

	     setEnabled(true);
//	     set_actuallistitem();
	  }
 	else setEnabled(false);
 }
 else
   {
     setEnabled(false);
   }
  setFocusPolicy(StrongFocus);

}



bool hk_kdecombobox::datasource_enable(void)
{
#ifdef HK_DEBUG
hkdebug("kdecombobox::datasource_enable");
#endif
 	bool erg=hk_dscombobox::datasource_enable();
	load_listitems();
//	set_actuallistitem();
        return erg;
}

bool hk_kdecombobox::datasource_disable(void)
{
#ifdef HK_DEBUG
hkdebug("kdecombobox::datasource_disable");
#endif
 clear();//clears the columnbox
 if (listdatasource()!=NULL) listdatasource()->disable();
 //viewcolumn()=NULL;
 //listcolumn()=NULL;
 return hk_dsdatavisible::datasource_disable();

}



void hk_kdecombobox::set_actuallistitem(void)
{
#ifdef HK_DEBUG
hkdebug("kdecombobox::set_actuallistitem");
#endif
	if (datasource()==NULL) return;
	if (column()==NULL) return;

	if((listcolumn()==NULL)||(listdatasource()==NULL)||(viewcolumn()==NULL))
	 {
	     if (column()!=NULL) setEditText(column()->asstring().c_str());
	     {
		return;
	     }
	 }
	unsigned int r= column()->has_changed() ? listcolumn()->find(column()->changed_data_asstring())
						: listcolumn()->find(column()->asstring());
	if (r<=listdatasource()->max_rows())
	{
		setEditText(viewcolumn()->asstring_at(r).c_str());
	}else   clearEdit();
#ifdef HK_DEBUG
hkdebug("kdecombobox::set_actuallistitemENDE");
#endif

}

void hk_kdecombobox::set_selecteditemdata(int index)
{
#ifdef HK_DEBUG
hkdebug("kdecombobox::set_selecteditemdata");
#endif
	blockSignals(true);
	if((listcolumn()==NULL)||(listdatasource()==NULL)||(viewcolumn()==NULL)||(column()==NULL)) return;
	unsigned int r=viewcolumn()->find(text(index).latin1());
	if (r<listdatasource()->max_rows())
	{
 	#ifdef HK_DEBUG
 	hkdebug("r= ",(int)r);
 	hkdebug(viewcolumn()->asstring_at(r),listcolumn()->asstring_at(r));
 	#endif
		column()->set_asstring(listcolumn()->asstring_at(r));

	}
        clear();
        for (unsigned int k=0;k<listdatasource()->max_rows();k++) insertItem(viewcolumn()->asstring_at(k).c_str());

	setEditText(viewcolumn()->asstring_at(r).c_str());
	blockSignals(false);
}

bool hk_kdecombobox::widget_specific_coordinates(uint px,uint py,uint pwidth,uint pheight)
{
	setGeometry(px,py,pwidth,pheight);
	qApp->processEvents();
 return true;
}

void hk_kdecombobox::resizeEvent ( QResizeEvent * event )
{
#ifdef HK_DEBUG
hkdebug("kdecombobox::resizeEvent");
#endif
  KComboBox::resizeEvent(event);
  reposition();

}


void  hk_kdecombobox::moveEvent ( QMoveEvent * event)
{
#ifdef HK_DEBUG
hkdebug("kdecombobox::resizeEvent");
#endif
    KComboBox::moveEvent(event);
    reposition();
}

void hk_kdecombobox::reposition(void)
{
#ifdef HK_DEBUG
hkdebug("kdecombobox::reposition");
#endif
  if (p_form==NULL ||p_setcoordinates==true) return;
  p_setwidgetcoordinates=true;
    unsigned int ppx=p_form->horizontal2relativ(KComboBox::x());
    unsigned int ppy=p_form->vertical2relativ(KComboBox::y());
    unsigned int pph=p_form->vertical2relativ(KComboBox::height(),p_dynamicheight);
    unsigned int ppw=p_form->horizontal2relativ(KComboBox::width(),p_dynamicwidth);
    set_size(ppx,ppy,ppw,pph,p_dynamicwidth,p_dynamicheight);
  p_setwidgetcoordinates=false;
}

void	hk_kdecombobox::widget_specific_insert_mode(void)
{
   blockSignals(true);
   setEditText("");
   blockSignals(false);
}


void  hk_kdecombobox::load_listitems(void)
{
#ifdef HK_DEBUG
hkdebug("kdecombobox::load_listitems");
#endif
	blockSignals(true);
	clear();
	if  (listdatasource()==NULL)
		{
		  //cout <<"listdatasource==NULL"<<endl;
		  return;
		}
        unsigned int r=listdatasource()->max_rows();
	if (viewcolumn()!=NULL)
	{
	 for (unsigned int k=0;k<r;k++)
         {
          insertItem(viewcolumn()->asstring_at(k).c_str());
         }
	}
set_actuallistitem();
  blockSignals(false);
}

