// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.29 $

#include "hk_kdeform.h"
#include "hk_kdeform.moc"
#include "hk_kdetoolbar.h"

#include <qbuttongroup.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <hk_kdesimpleform.h>
#include <qtoolbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qbuttongroup.h>
#include <qscrollview.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <hk_kderowselector.h>
#include <hk_class.h>
#include <hk_database.h>
#include <hk_dsvisible.h>
#include <hk_visible.h>
#include <hk_dsdatavisible.h>


static const char* const image2_data[] = {
"22 22 2 1",
". c None",
"# c #000000",
"......................",
"......................",
"......................",
"......................",
"......................",
".......#..............",
".......##.............",
".......###............",
".......####...........",
".......#####..........",
".......######.........",
".......#######........",
".......#####..........",
".......#####..........",
".......#..###.........",
"..........###.........",
"...........###........",
"...........###........",
"......................",
"......................",
"......................",
"......................"};

static const char* const image3_data[] = {
"22 22 6 1",
". c None",
"# c #000000",
"d c #00007b",
"a c #4a504a",
"b c #f6f6f6",
"c c #ffffff",
"......................",
"......................",
"......................",
"......................",
".####################.",
"##aaaaaaaaaaaaaaaaaa##",
"#aabcccccccccc##c##cc#",
"#abccccccddccccc#cccc#",
"#abccccccddccccc#cccb#",
"#accdddccddddccc#cccc#",
"#accccddcddcddcc#cccc#",
"#accddddcddcddcc#cccc#",
"#acddcddcddcddcc#cccc#",
"#acddcddcddcddcc#cccc#",
"#accddddcddddccc#cccc#",
"#acccccccccccc##c##cc#",
"##bbbbbbbbbbbbbbbbbb##",
".####################.",
"......................",
"......................",
"......................",
"......................"};

static const char* const image4_data[] = {
"22 22 20 1",
". c None",
"r c #000000",
"o c #000083",
"# c #080c08",
"m c #10108b",
"p c #202094",
"k c #31309c",
"i c #4144a4",
"f c #5255ac",
"c c #6265b4",
"e c #7375bd",
"d c #8b89c5",
"n c #9c99cd",
"g c #acaad5",
"l c #bdbade",
"h c #cdcee6",
"j c #dedeee",
"b c #eeeef6",
"q c #f6faff",
"a c #ffffff",
".####################.",
"##aaaaaaaabcdaaaaaaa##",
"#aaaaaaaaaaddaaaaaaaa#",
"#aaaaaaaaaaddaaaaaaaa#",
"#abdedaabddfdaagechaa#",
"#aijakdafbaidaldahmba#",
"#hiaajbndaaddafcddiha#",
"#lkaaabddaaddaigaaaaa#",
"#bogaadnpaaddaekbalja#",
"#anoifbafieiibbkmicaa#",
"#aajlaaaahjjaaaalhaaa#",
"#aaaaaaagpaaaaaaaaaaa#",
"#aaaaaaaaoaaaaaaaaaaa#",
"#aaaqaaaaoaaaaaararaa#",
"#aaleedaaolfcbaaaraaa#",
"#aamaaklaohaccaaaraaa#",
"#aajjdplaoaaboaaaraaa#",
"#aaedbilaoaaaoaaaraaa#",
"#ahiaailaoaahfaaaraaa#",
"#ajmeekcjidlcbaararaa#",
"##ajlajjaahhaaaaaaaa##",
".####################."};

static const char* const image5_data[] = {
"22 22 5 1",
"# c None",
". c None",
"a c #000000",
"b c #5a595a",
"c c #ffffff",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#.#.#.#.#.#.#.#.#.",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#.#.#.#.#.#.#.#.#.",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#aaaaaaaaaaaa.#.#.",
".#.#.a.#.#.#.#.#b#.#.#",
"#.#.#a#aaccccaacb.#.#.",
".#.#.a.aaaccaaacb#.#.#",
"#.#.#a#caaaaaaccb.#.#.",
".#.#.a.ccaaaacccb#.#.#",
"#.#.#a#ccaaaacccb.#.#.",
".#.#.a.caaaaaaccb#.#.#",
"#.#.#a#aaaccaaacb.#.#.",
".#.#.a.aaccccaacb#.#.#",
"#.#.#accccccccccb.#.#.",
".#.#.abbbbbbbbbbb#.#.#",
"#.#.#.#.#.#.#.#.#.#.#.",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#.#.#.#.#.#.#.#.#.",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#.#.#.#.#.#.#.#.#."};

static const char* const image6_data[] = {
"22 22 6 1",
"# c None",
". c None",
"a c #000000",
"d c #000083",
"c c #5a595a",
"b c #ffffff",
".#.#.#.#.#.#.#.#.#.#.#",
"aaaaaaaaaaaaaaaaaaaaaa",
"abbbbbbbbbbbbbbba#.#.a",
"abbbbbbbbbbbbbbba.cc#a",
"abbbbbbbbbbbbbbba#.#.a",
"aaaaaaaaaaaaaaaaaaaaaa",
".aaaaaaaaaaaaaaaaaaaaa",
"#abbbbbbbbbbbbbbbbbbba",
".abbbbbbbbbbbbbbbbbbba",
"#abbaaaaaaaaaaaaaaabba",
".abbaaaaaaaaaaaaaaabba",
"#abbbbbbbbbbbbbbbbbbba",
".abbbbbbbbbbbbbbbbbbba",
"#abbdddddddddddddddbba",
".abbdddddddddddddddbba",
"#abbbbbbbbbbbbbbbbbbba",
".abbbbbbbbbbbbbbbbbbba",
"#abbaaaaaaaaaaaaaaabba",
".abbaaaaaaaaaaaaaaabba",
"#abbbbbbbbbbbbbbbbbbba",
".abbbbbbbbbbbbbbbbbbba",
"#aaaaaaaaaaaaaaaaaaaaa"};

static const char* const image7_data[] = {
"22 22 9 1",
"# c None",
". c None",
"a c #000000",
"f c #838183",
"e c #a4a1a4",
"g c #c5c2c5",
"c c #c5c6c5",
"d c #cdc6cd",
"b c #ffffff",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#.#.#.#.#.#.#.#.#.",
"aaaaaaaaaaaaaaaaaaaaaa",
"ab#.ab#.#.#.#ab.#.#.#a",
"acdca#.#.#.#ea.#.#.#fa",
"adgeaeeeeeeeeagffffffa",
"aaaaaaaaaaaaaaaaaaaaaa",
"ab#.abbbbbbbbabbbbbbba",
"a#.#abbbbbbbbabbbbbbba",
"a.#.abbbbbbbbabbbbbbba",
"afffaffffffffafffffffa",
"ab#.abbbbbbbbabbbbbbba",
"a#.#abbbbbbbbabbbbbbba",
"a.#.abbbbbbbbabbbbbbba",
"afffaffffffffafffffffa",
"ab#.abbbbbbbbabbbbbbba",
"a#.#abbbbbbbbabbbbbbba",
"aaaaaaaaaaaaaaaaaaaaaa",
"acdcdcdcdcdcdcdcdcdcda",
"aaaaaaaaaaaaaaaaaaaaaa",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#.#.#.#.#.#.#.#.#."};

static const char* const image8_data[] = {
"22 22 38 1",
". c None",
"o c #000431",
"e c #000439",
"h c #000441",
"F c #000839",
"u c #000c41",
"g c #000c4a",
"y c #081441",
"d c #08144a",
"I c #101439",
"k c #10144a",
"c c #101841",
"n c #10184a",
"w c #182052",
"z c #202039",
"m c #202452",
"r c #202852",
"s c #292c41",
"j c #29345a",
"C c #31344a",
"J c #313452",
"H c #393c41",
"b c #393c62",
"q c #414862",
"i c #4a4c62",
"B c #4a506a",
"x c #5a5d6a",
"E c #5a5d73",
"a c #62656a",
"A c #626573",
"p c #6a6d6a",
"t c #6a6d7b",
"v c #6a717b",
"G c #737573",
"f c #73757b",
"D c #7b7d7b",
"l c #7b7d83",
"# c #838583",
"......................",
"......................",
"..........#a..........",
"..........bc..........",
".........#de#.........",
".........fghi.........",
".........jkgc#........",
"........#blghl........",
"........jl.jhm........",
".......#n..#gop.......",
".......qb...rhs.......",
".......j#...thu#......",
"......vw####tdex......",
"......byzmzzcuhc......",
".....#m######Ahof.....",
".....BA.......weC.....",
"....#n#.......fhoD....",
"....Er.........yes....",
"..#xgFG#.....#ayheH#..",
"..xnrrIl.....tzrrrcJ..",
"......................",
"......................"};

static const char* const image9_data[] = {
"22 22 17 1",
". c None",
"l c #000000",
"m c #101010",
"j c #181818",
"o c #313031",
"n c #414441",
"g c #525552",
"k c #6a696a",
"i c #7b797b",
"e c #8b898b",
"h c #9c9d9c",
"f c #acaeac",
"c c #bdbebd",
"b c #cdcecd",
"# c #e6e2e6",
"a c #f6f2f6",
"d c #ffffff",
"......................",
"......................",
".#####a#aaa#####bbbc#.",
"#dddddddddddddddddabeb",
"cddddddddddaaa##bccfeg",
"ca#bcbbcbccfccfffchhij",
"fbbcbkllmhcfmkfcelkhej",
"fbccnllmllhflobhllehij",
"fbbhlobchlmclocllhfeim",
"fbbolffhcolflnjlefheij",
"fcbmlffffklellllchheij",
"fbbllffhfklellllifeekj",
"hcbjlfhhcnlhllcllfheim",
"hccelobcfllflocilofekm",
"fcfcolmolleflmffllkhim",
"hcfhfolllifhlnhheljhkm",
"hffhhfhehhhehheeheeekm",
"hfhheeheeeieeeeeeeeeno",
"bgkkkgkggggggggggggnlc",
".cnjlllllllllllllmmnh.",
"......................",
"......................"};

static const char* const image10_data[] = {
"22 22 4 1",
"# c None",
". c None",
"a c #000000",
"b c #ffffff",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#.#.#.#.#.#.#.#.#.",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#.#.#.#.#.#.#.#.#.",
"aaaaaaaaaaaaaaaaaaaaaa",
"abbbbbbabbbbbbabbbbbba",
"ab.#.#.abbbbbbab.#.#.a",
"ab#.a.#abbbbbbab#a#.#a",
"ab.aa#.abbbbbbab.aa#.a",
"abaaa.#abbbbbbab#aaa#a",
"ab.aa#.abbbbbbab.aa#.a",
"ab#.a.#abbbbbbab#a#.#a",
"ab.#.#.abbbbbbab.#.#.a",
"ab#.#.#abbbbbbab#.#.#a",
"aaaaaaaaaaaaaaaaaaaaaa",
"#.#.#.#.#.#.#.#.#.#.#.",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#.#.#.#.#.#.#.#.#.",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#.#.#.#.#.#.#.#.#.",
".#.#.#.#.#.#.#.#.#.#.#",
"#.#.#.#.#.#.#.#.#.#.#."};



/*
 *  Constructs a hk_kdeform which is a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'
 */
hk_kdeform::hk_kdeform( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl ) ,hk_class()
{
#ifdef HK_DEBUG
hkclassname("Hauptformular");
hkdebug("hk_kdeform::hk_kdeform");
#endif
    QPixmap image2( ( const char** ) image2_data );
    QPixmap image3( ( const char** ) image3_data );
    QPixmap image4( ( const char** ) image4_data );
    QPixmap image5( ( const char** ) image5_data );
    QPixmap image6( ( const char** ) image6_data );
    QPixmap image7( ( const char** ) image7_data );
    QPixmap image8( ( const char** ) image8_data );
    QPixmap image9( ( const char** ) image9_data );
    QPixmap image10( ( const char** ) image10_data );
    if ( !name )
	setName( "hk_kdeform" );
    resize( 588, 480 );
    setCaption( hk_class::hk_translate( "Form"  ).c_str() );
    hk_kdeformLayout = new QVBoxLayout( this );
    hk_kdeformLayout->setSpacing( 0 );
    hk_kdeformLayout->setMargin( 0 );

    toolbar = new hk_kdetoolbar( this, "toolbar" );
    toolbar->show_searchbutton(false);
    hk_kdeformLayout->addWidget( toolbar );


    Layoutgrid_formtool = new QHBoxLayout;
    Layoutgrid_formtool->setSpacing( 0 );
    Layoutgrid_formtool->setMargin( 0 );

    formbuttongroup = new QButtonGroup( this, "formbuttongroup" );
    formbuttongroup->setColumnLayout(0, Qt::Vertical );
    formbuttongroup->setExclusive( TRUE );
    formbuttongroup->layout()->setSpacing( 0 );
    formbuttongroup->layout()->setMargin( 0 );
    formbuttongroupLayout = new QVBoxLayout( formbuttongroup->layout() );
    formbuttongroupLayout->setAlignment( Qt::AlignTop );
    formbuttongroupLayout->setSpacing( 1 );
    formbuttongroupLayout->setMargin( 3 );

    formpointerbutton = new QToolButton( formbuttongroup, "formpointerbutton" );
    formpointerbutton->setPixmap(  image2   );
    formpointerbutton->setToggleButton( TRUE );
    formbuttongroup->insert( formpointerbutton, 5 );
    formpointerbutton->setOn(true);
    formpointerbutton->setAutoRaise( FALSE );
    formbuttongroupLayout->addWidget( formpointerbutton );


    formlabelbutton = new QToolButton( formbuttongroup, "labelbutton" );
    formlabelbutton->setPixmap( image8 );
    formlabelbutton->setToggleButton( TRUE );
    formbuttongroup->insert( formlabelbutton, 5 );
    formbuttongroupLayout->addWidget( formlabelbutton );



    formlineeditbutton = new QToolButton( formbuttongroup, "formlineeditbutton" );
    formlineeditbutton->setPixmap(  image3   );
    formlineeditbutton->setToggleButton( TRUE );
    formbuttongroup->insert( formlineeditbutton, 5 );
    formbuttongroupLayout->addWidget( formlineeditbutton );

    formtablebutton = new QToolButton( formbuttongroup, "formtablebutton" );
    formtablebutton->setPixmap(  image7   );
    formtablebutton->setToggleButton( TRUE );
    formbuttongroup->insert( formtablebutton, 5 );
    formbuttongroupLayout->addWidget( formtablebutton );

    formmultilineeditbutton = new QToolButton( formbuttongroup, "formmultilineeditbutton" );
    formmultilineeditbutton->setPixmap(  image4   );
    formmultilineeditbutton->setToggleButton( TRUE );
    formbuttongroup->insert( formmultilineeditbutton, 5 );
    formbuttongroupLayout->addWidget( formmultilineeditbutton );

    formbooleanbutton = new QToolButton( formbuttongroup, "formbooleanbutton" );
    formbooleanbutton->setPixmap(  image5   );
    formbooleanbutton->setToggleButton( TRUE );
    formbuttongroup->insert( formbooleanbutton, 5 );
    formbuttongroupLayout->addWidget( formbooleanbutton );

    formcomboboxbutton = new QToolButton( formbuttongroup, "formcomboboxbutton" );
    formcomboboxbutton->setPixmap(  image6   );
    formcomboboxbutton->setToggleButton( TRUE );
    formbuttongroup->insert( formcomboboxbutton, 5 );
    formbuttongroupLayout->addWidget( formcomboboxbutton );

    formbuttonbutton = new QToolButton( formbuttongroup, "formbuttonbutton" );
    formbuttonbutton->setPixmap(  image9   );
    formbuttonbutton->setToggleButton( TRUE );
    formbuttongroup->insert( formbuttonbutton, 5 );
    formbuttongroupLayout->addWidget( formbuttonbutton );

    formselectorbutton = new QToolButton( formbuttongroup, "formselectorbutton" );
    formselectorbutton->setPixmap(  image10   );
    //formselectorbutton->setText("...");
    formselectorbutton->setToggleButton( TRUE );
    formbuttongroup->insert( formselectorbutton, 5 );
    formbuttongroupLayout->addWidget( formselectorbutton );

    Layoutgrid_formtool->addWidget( formbuttongroup );

    QToolTip::add(  formpointerbutton, hk_translate( "select" ).c_str() );
    QToolTip::add(  formlineeditbutton, hk_translate( "lineeditfield" ).c_str() );
    QToolTip::add(  formbooleanbutton, hk_translate( "booleanfield" ).c_str() );
    QToolTip::add(  formcomboboxbutton, hk_translate( "comboboxfield" ).c_str() );
    QToolTip::add(  formtablebutton, hk_translate( "tablefield" ).c_str() );
    QToolTip::add(  formmultilineeditbutton, hk_translate( "memofield" ).c_str() );

    QToolTip::add(  formbuttonbutton, hk_translate( "button" ).c_str() );
    QToolTip::add(  formselectorbutton, hk_translate( "rowselector" ).c_str() );
    QToolTip::add(  formlabelbutton, hk_translate( "textlabel" ).c_str() );

    p_scrollview = new QScrollView(this);
    Layoutgrid_formtool->addWidget( p_scrollview );
    hk_kdeformLayout->addLayout( Layoutgrid_formtool );

    p_form = new hk_kdesimpleform( p_scrollview->viewport() );

    p_form->set_kdeform(this);
    p_scrollview->addChild(p_form);

    Layout3 = new QHBoxLayout;
    Layout3->setSpacing( 6 );
    Layout3->setMargin( 0 );

    p_rowselector = new hk_kderowselector( this ,p_form);
    #ifdef HK_DEBUG
    p_rowselector->hkclassname("hkkdeform->p_rowselector");
    #endif
    p_rowselector->set_neverregisterchange(true);
    Layout3->addWidget( p_rowselector );

    infolabel = new QLabel( this, "infolabel" );
    infolabel->setText(  ""   );
    infolabel->setFocusPolicy(NoFocus);
    Layout3->addWidget( infolabel );
    hk_kdeformLayout->addLayout( Layout3 );

   QSizePolicy fixedpolicy(QSizePolicy::Fixed,QSizePolicy::Fixed);
   QSizePolicy labelpolicy(QSizePolicy::Expanding,QSizePolicy::Fixed);
    p_rowselector->setSizePolicy( fixedpolicy );
    infolabel->setSizePolicy(labelpolicy);
   int hbheight= 20;
   p_rowselector->setMaximumHeight(hbheight);
   p_rowselector->setMaximumWidth(160);
   p_rowselector->setMinimumHeight(hbheight);
    connect( p_form, SIGNAL( closeform() ), this, SLOT( close() ) );
    connect( formpointerbutton, SIGNAL( clicked() ), this, SLOT( fieldbutton_clicked() ) );
    connect( formlineeditbutton, SIGNAL( clicked() ), this, SLOT( fieldbutton_clicked() ) );
    connect( formlabelbutton, SIGNAL( clicked() ), this, SLOT( fieldbutton_clicked() ) );
    connect( formmultilineeditbutton, SIGNAL( clicked() ), this, SLOT( fieldbutton_clicked() ) );
    connect( formbooleanbutton, SIGNAL( clicked() ), this, SLOT( fieldbutton_clicked() ) );
    connect( formtablebutton, SIGNAL( clicked() ), this, SLOT( fieldbutton_clicked() ) );
    connect( formcomboboxbutton, SIGNAL( clicked() ), this, SLOT( fieldbutton_clicked() ) );
    connect( formbuttonbutton, SIGNAL( clicked() ), this, SLOT( fieldbutton_clicked() ) );
    connect( formselectorbutton, SIGNAL( clicked() ), this, SLOT( fieldbutton_clicked() ) );
    connect( p_form, SIGNAL( field_created() ), this, SLOT( field_created() ) );
    connect( toolbar, SIGNAL( signal_savebutton_clicked() ), this, SLOT( save_form() ) );
    connect( toolbar, SIGNAL( signal_designmode_selected() ), this, SLOT( designbutton_clicked() ) );
    connect( toolbar, SIGNAL( signal_viewmode_selected() ), this, SLOT( formbutton_clicked() ) );
    setFocusPolicy(ClickFocus);
    set_nodesignmode(runtime_only());
}

/*
 *  Destroys the object and frees any allocated resources
 */
hk_kdeform::~hk_kdeform()
{
 #ifdef HK_DEBUG
hkdebug("hk_kdeform::~hk_kdeform");
#endif
    // no need to delete child widgets, Qt does it all for us
}

hk_presentation::enum_mode	hk_kdeform::mode(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::mode");
#endif

    return p_form->mode();
}
void 	hk_kdeform::set_mode(hk_presentation::enum_mode s)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::set_mode(s)");
#endif

  p_form->set_mode(s);

  if (s==hk_presentation::view)
  {
     toolbar->set_viewmode();
     formbuttongroup->hide();
  }
  else
  {
     toolbar->set_designmode();
     formbuttongroup->show();
  }
     p_form->repaint(0,0,p_form->QWidget::width(),p_form->QWidget::height(),true);

}

void hk_kdeform::set_designmode(void)
{
  set_mode(hk_presentation::design);
}

void hk_kdeform::set_viewmode(void)
{
  set_mode(hk_presentation::view);
}

hk_dsgrid*		hk_kdeform::new_grid(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::new_grid");
#endif
  hk_dsgrid* d=p_form->new_grid();
  return d;
}

hk_dslineedit* 	hk_kdeform::new_lineedit(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::new_field");
#endif
  hk_dslineedit* d=p_form->new_lineedit();
  return d;
}

hk_dsboolean* 	hk_kdeform::new_bool(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::new_bool");
#endif
  hk_dsboolean* d=p_form->new_bool();
  return d;
}

hk_dsmemo* 	hk_kdeform::new_memo(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::new_memo");
#endif
  hk_dsmemo* d=p_form->new_memo();
  return d;
}

hk_button* 		hk_kdeform::new_button(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::new_button");
#endif
	hk_button* d=p_form->new_button();
	return d;
}

hk_dsrowselector* 		hk_kdeform::new_rowselector(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::new_rowselector");
#endif
	hk_dsrowselector* d=p_form->new_rowselector();
	return d;
}

void		hk_kdeform::set_formsize(unsigned int width, unsigned int height)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::set_formsize");
#endif
  p_form->set_formsize(width,height);
}



void	hk_kdeform::set_database(hk_database* db)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::database(db)");
#endif

	p_form->set_database(db);
}


hk_database* 		hk_kdeform::database(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::database");
#endif
   return p_form->database();
}


list<hk_datasource*>*	hk_kdeform::datasources(void)
{
 #ifdef HK_DEBUG
hkdebug("hk_kdeform::datasources");
#endif
  return p_form->datasources();
}


long	hk_kdeform::new_datasource(const hk_string& name,bool query)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::new_datasource(name,query)");
#endif
	return p_form->new_datasource(name,query);
}



hk_datasource* 	hk_kdeform::get_datasource(long nr)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::get:datasource(nr)");
#endif
     return p_form->get_datasource(nr);
}



void hk_kdeform::formbutton_clicked(void)
{
   set_mode(hk_presentation::view);

}

void hk_kdeform::designbutton_clicked(void)
{
   if (p_nodesignmode)  set_mode(hk_form::view);
   else set_mode(hk_form::design);

}

bool	hk_kdeform::set_presentationdatasource(long n, bool r)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::set_presentationdatasource(n)");
#endif
   p_rowselector->set_presentationdatasource(n,false);
   toolbar->set_datasource(p_form->get_datasource(n));
   bool res=true;
   if (r) res= p_form->set_presentationdatasource(n,false);
   return res;
}

long  	hk_kdeform::presentationdatasource(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::presentationdatasource(n)");
#endif
    return p_form->presentationdatasource();
}

void hk_kdeform::closeEvent ( QCloseEvent* e)
{

#ifdef HK_DEBUG
hkdebug("hk_kdeform::closeEvent");
//set_generaldebug(true);
#endif

   if (p_form->has_changed())
    {
       p_form->save_form();
    }
#ifdef HK_DEBUG
hkdebug("hk_kdeform::closeEvent nach abspeichern");
#endif

 QWidget::closeEvent(e);

#ifdef HK_DEBUG
hkdebug("hk_kdeform::closeEvent nach QWidget::closeEvent");
#endif

}

void hk_kdeform::savedata(ofstream& s)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::savedata(s)");
#endif
   p_form->savedata(s);

}

void hk_kdeform::loaddata(const hk_string& definition)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::loaddata");
#endif
   p_form->loaddata(definition);
   p_rowselector->set_presentationdatasource(p_form->presentationdatasource());
}

void hk_kdeform::load_form(const hk_string& n)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::load_form");
#endif

   if (database()==NULL)
  {
   hk_class::show_warningmessage(hk_class::hk_translate("Form error: No database defined!"));
   return ;

  }
//  p_form->formname(n);
  p_form->load_form(n);
   p_rowselector->set_presentationdatasource(p_form->presentationdatasource(),false);
   QString formname=hk_class::hk_translate( "Form: "  ).c_str();
   formname+=p_form->hk_presentation::name().c_str();
   setCaption( formname  );

}



void hk_kdeform::set_autoclose(bool c)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::set_autoclose");
#endif
	p_form->set_autoclose(c);
}



void hk_kdeform::fieldbutton_clicked(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::fieldbutton_clicked");
#endif

     hk_visible::enum_visibletype thisfield =hk_visible::other;
     if (formlineeditbutton->isOn()) thisfield=hk_visible::lineedit;
else
     if (formlabelbutton->isOn()) thisfield=hk_visible::textlabel;
else
     if (formmultilineeditbutton->isOn()) thisfield=hk_visible::memo;
else
     if (formcomboboxbutton->isOn()) thisfield=hk_visible::combobox;
else
     if (formtablebutton->isOn()) thisfield=hk_visible::grid;
else
     if (formbooleanbutton->isOn()) thisfield=hk_visible::boolean;
else
     if (formbuttonbutton->isOn()) thisfield=hk_visible::button;
else
     if (formselectorbutton->isOn()) thisfield=hk_visible::rowselector;
     p_form->set_field2create(thisfield);
}


void 	hk_kdeform::mousePressEvent(QMouseEvent*m)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::mousePressEvent");
#endif
QWidget::mousePressEvent(m);

}

void hk_kdeform::field_created(void)
{
     formpointerbutton->setOn(true);
}

hk_kdesimpleform* hk_kdeform::simpleform(void)
{
   return p_form;
}


void hk_kdeform::set_nodesignmode(bool d)
{
 p_nodesignmode=d;
 toolbar->set_nodesignmode(d);


}

void hk_kdeform::save_form(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdeform::save_form");
#endif
 if (toolbar->is_filter_activated())
 	toolbar->deactivate_filter();
 p_form->save_form("",false);
  QString formname=hk_class::hk_translate( "Form: "  ).c_str();
   formname+=p_form->hk_presentation::name().c_str();
   setCaption( formname  );

}


