// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.18 $
#include "hk_class.h"
#include <hk_kdegrid.h>
#include <hk_kdegrid.moc>
#include <hk_kderowselector.h>
#include <qpainter.h>
#include <qpalette.h>
#include <qdrawutil.h>
#include <qscrollbar.h>
#include <qsizepolicy.h>
#include <hk_kdesimpleform.h>
#include "hk_dsgridcolumn.h"
#include "hk_kdefinddialog.h"
#include <qcheckbox.h>
#include <qcombobox.h>


//*******************************
//***       hk_kdegrid        ***
//*******************************

hk_kdegrid::hk_kdegrid(QWidget* wid,const char* n,WFlags f,hk_kdesimpleform* form)
   : QFrame(wid,n,f) ,hk_dsgrid(form)
{
#ifdef HK_DEBUG
hkdebug("hk_kdegrid::hk_kdegrid");
#endif
   QSizePolicy policy(QSizePolicy::Expanding,QSizePolicy::Expanding);
   QSizePolicy fixedpolicy(QSizePolicy::Fixed,QSizePolicy::Fixed);
   QSizePolicy labelpolicy(QSizePolicy::Expanding,QSizePolicy::Fixed);
   QSizePolicy vheaderpolicy(QSizePolicy::Fixed,QSizePolicy::Expanding);
   QSizePolicy hheaderpolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
   if (wid!=NULL)setFrameStyle(Box|Sunken);
   hbottomlayout= new QHBoxLayout;
   hdatalayout=new QHBoxLayout;
   htoplayout=new QHBoxLayout;
   vbasiclayout  = new QVBoxLayout(this,3,0,0);
   topleftbutton=new QPushButton(this);
   grid		 = new hk_kdesimplegrid(this,this,form);
   selector	 = new hk_kderowselector(this,form);
   statusbar	= new QLabel(this);
   hheader	= new hk_hheader(this);
   vheader	= new hk_vheader(this);
   selector->setSizePolicy(fixedpolicy);
   statusbar->setSizePolicy(labelpolicy);
   grid->setSizePolicy(policy);
   hheader->addLabel("",default_cellwidth);
//   vheader->addLabel("",default_cellheight);
   vbasiclayout->addLayout(htoplayout,0);
   vbasiclayout->addLayout(hdatalayout,1);
   vbasiclayout->addLayout(hbottomlayout,0);
   hheader->setOrientation(QHeader::Horizontal);
//   vheader->setOrientation(QHeader::Vertical);
   topleftbutton->setEnabled(false);
   topleftbutton->setSizePolicy(fixedpolicy);
   int vlwidth= 30;
   int hbheight= 20;
   int htheight=20;
   htoplayout->addWidget(topleftbutton);
   htoplayout->addWidget(hheader);
   topleftbutton->setMinimumHeight(htheight);
   topleftbutton->setMaximumHeight(htheight);
   topleftbutton->setMaximumWidth(vlwidth);
   hheader->setMinimumHeight(htheight);
   hheader->setMaximumHeight(htheight);
    hheader->setSizePolicy(hheaderpolicy);
   hdatalayout->addWidget(vheader);
   vheader->setMinimumWidth(vlwidth);
   vheader->setMaximumWidth(vlwidth);
   vheader->set_cellwidth(default_cellwidth);
    vheader->setSizePolicy(vheaderpolicy);
   hdatalayout->addWidget(grid);
   hbottomlayout->addWidget(selector);
   hbottomlayout->addWidget(statusbar);
   hbottomlayout->setEnabled(true);
   statusbar->setFrameStyle(WinPanel|Sunken);
   statusbar->setMidLineWidth(0);
   statusbar->setLineWidth(1);
   statusbar->setText("STATUS");
   selector->setMaximumHeight(hbheight);
   selector->setMaximumWidth(160);
   selector->setMinimumHeight(hbheight);
   statusbar->setMaximumHeight(hbheight);
   vbasiclayout->setEnabled(true);
   vbasiclayout->activate();
   grid->set_headers(hheader,vheader,statusbar);
   grid->set_rowselector(selector);
   p_visibletype=hk_visible::grid;
   p_finddialog=NULL;
   p_findfirstview=true;
}



hk_kdegrid::~hk_kdegrid()
{
#ifdef HK_DEBUG
hkdebug("hk_kdegrid::~hk_kdegrid");
#endif
   p_form=NULL;
   p_presentation=NULL;
}

void hk_kdegrid::set_datasource(hk_datasource* d)
{
#ifdef HK_DEBUG
hkdebug("hk_kdegrid::datasource(hk_datasource* d)");
#endif
 grid->set_datasource(d);
 selector->set_datasource(d);
 hk_dsgrid::set_datasource(d);
}


/**
void hk_kdegrid::datasource_enables(void)
{
  hheader->setEnabled(true);
  vheader->setEnabled(true);
  topleftbutton->setEnabled(true);
}

void hk_kdegrid::datasource_disables(void)
{
  for(int i=0;i<hheader->count();i++)
  {if (i==0)hheader->setLabel(i,"",10);else hheader->setLabel(i,"",0);}

  hheader->setEnabled(false);
  vheader->setEnabled(false);
  topleftbutton->setEnabled(false);
}
*/



bool hk_kdegrid::widget_specific_coordinates(uint px,uint py,uint pwidth,uint pheight)
{
#ifdef HK_DEBUG
hkdebug("hk_kdegrid::widget_specific_coordinates");
#endif
   unsigned int ppx=px;
   unsigned int ppy=py;
   unsigned int ppw=pwidth;
   unsigned int pph=pheight;
   if (p_form!=NULL)
   {

    ppx=p_form->horizontal2relativ(ppx);
    ppy=p_form->vertical2relativ(ppy);
    pph=p_form->vertical2relativ(pph,p_dynamicheight);
    ppw=p_form->horizontal2relativ(ppw,p_dynamicwidth);


   }
	blockSignals(true);
	setGeometry(px,py,pwidth,pheight);
	if (p_form!=NULL) grid->set_size(ppx,ppy,ppw,pph);
	blockSignals(false);
 return true;
}



void hk_kdegrid::widget_specific_presentationdatasource(long n)
{
#ifdef HK_DEBUG
hkdebug("hk_kdegrid::widget_specific_presentationdatasource");
#endif

// hk_dsvisible::presentationdatasource(n);

 grid->set_presentationdatasource(n);
  selector->set_presentationdatasource(n,false);

}

void hk_kdegrid::widget_specific_enable_disable(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdegrid::widget_specific_enable_disable");
#endif
 if (p_form!=NULL) if (p_form->mode()==hk_form::design)
 {
    setFocusPolicy(NoFocus);
    setEnabled(true);
  }
  else setFocusPolicy(StrongFocus);

}

void hk_kdegrid::reposition(void)
{
#ifdef HK_DEBUG
hkdebug("kdegrid::reposition");
#endif
  if (p_form==NULL ||p_setcoordinates==true) return;
  p_setwidgetcoordinates=true;
    unsigned int ppx=p_form->horizontal2relativ(QFrame::x());
    unsigned int ppy=p_form->vertical2relativ(QFrame::y());
    unsigned int pph=p_form->vertical2relativ(QFrame::height(),p_dynamicheight);
    unsigned int ppw=p_form->horizontal2relativ(QFrame::width(),p_dynamicwidth);
    set_size(ppx,ppy,ppw,pph,p_dynamicwidth,p_dynamicheight);
  p_setwidgetcoordinates=false;
}

void hk_kdegrid::resizeEvent ( QResizeEvent * event )
{
#ifdef HK_DEBUG
hkdebug("kdegrid::resizeEvent");
#endif
 QFrame::resizeEvent(event);
  reposition();

}


void  hk_kdegrid::moveEvent ( QMoveEvent * event)
{
#ifdef HK_DEBUG
hkdebug("kdegrid::resizeEvent");
#endif
    QFrame::moveEvent(event);
    reposition();
}

void hk_kdegrid::find_clicked(void)
{
#ifdef HK_DEBUG
hkdebug("kdegrid::find_clicked");
#endif
    if (p_finddialog==NULL)
      {
         p_finddialog=new hk_kdefinddialog(this,0,false);
    	 connect(p_finddialog, SIGNAL(signal_findbutton_clicked()),this,SLOT(find_next()));
    	 connect(p_finddialog, SIGNAL(signal_findargument_changed()),this,SLOT(findargument_changed()));
      }

    p_findfirstview=true;
    findargument_changed();
    p_finddialog->show();
}

void 	hk_kdegrid::find_next(void)
{
#ifdef HK_DEBUG
hkdebug("kdegrid::find_next");
#endif
 bool search=true;
   if (p_finddialog==NULL)return;
while (search)
{
   if (p_finddialog->all_columnsbox->isChecked())
   {
     cout <<"noch nicht eingebaut"<<endl;
     search=false;
   }

   else
   {
    hk_column* c= grid->actual_column();
    if (c==NULL) return;
    unsigned int from=0;
    unsigned int to=0;
    if (p_finddialog->find_backwardsbox->isChecked())
    {

      from=0;
	to=((datasource()->row_position()>0)&&!p_findfirstview)?
    				datasource()->row_position()-1:
    				(p_findfirstview?datasource()->row_position():datasource()->max_rows()-1);
    }
    else
    {
	from=((datasource()->row_position()<datasource()->max_rows()-2)&&!p_findfirstview)?
    				datasource()->row_position()+1:
    				(p_findfirstview?datasource()->row_position():0);
	 to=datasource()->max_rows()-1;
    }

    unsigned int r=c->find(	from,
				to,
				p_finddialog->searchfield->currentText().latin1(),
				!p_finddialog->part_of_columnbox->isChecked(),
				p_finddialog->case_sensitivebox->isChecked(),
				p_finddialog->find_backwardsbox->isChecked()
			  );
    if (r<datasource()->max_rows())
    {
       datasource()->goto_row(r);
       search=false;
    }
    else
    {
     if (!p_findfirstview)
     {
       show_warningmessage(hk_translate("Not found."));
       search=false;
       return;
     }
     else
     {
        datasource()->goto_first();
     }


    }
   }

   p_findfirstview=false;
}

}


void hk_kdegrid::findargument_changed(void)
{
 p_findfirstview=true;

}


void  hk_kdegrid::before_row_change(void)
{
  grid->before_row_change();
}
