// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************

#ifndef HK_KDEGRID
#define HK_KDEGRID
#include <hk_kdesimplegrid.h>
#include <hk_class.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include <qheader.h>
//#include <qstatusbar.h>
#include <qwidget.h>
#include <qframe.h>
#include <qlabel.h>
#include "hk_dsgrid.h"
class hk_kderowselector;
class hk_kdesimpleform;
class hk_kdefinddialog;

/**
*
*@short  shows data in a grid without columnheaders.
*@version $Revision: 1.13 $
*@author Horst Knorr (hk_classes@knorrnet.de)
*
*This widget shows data of a datasource in a grid.
*If the data is not readonly you can edit the data just by typing
*in the cell. It has column and row headers and a rowselector.
*
*Just set the datasource and enable it. For details how you can use it
*see @ref hk_kdesimplegrid.
*/

class hk_kdegrid :public QFrame, public hk_dsgrid
{
	Q_OBJECT
	public:
	hk_kdegrid(QWidget* w=0,const char* n=0,WFlags f=0,hk_kdesimpleform* form=NULL);
virtual	~hk_kdegrid();
/**
* the datasource which data it has to show
*/
void	set_datasource(hk_datasource* d);
/**
* returns the use hk_kdesimplegrid. Please don't delete it !
*/
hk_kdesimplegrid* simplegrid(void){return grid;}
	public slots:
//	void datasource_enables(void);
//	void datasource_disables(void);
	void    find_clicked(void);
	void 	find_next(void);
	void  	findargument_changed(void);
	protected:
virtual bool		widget_specific_coordinates(unsigned int px,unsigned int py,unsigned int pwidth,unsigned int pheight);
virtual void	widget_specific_presentationdatasource(long p);
virtual void widget_specific_enable_disable(void);
virtual void resizeEvent (QResizeEvent *);
virtual void  moveEvent ( QMoveEvent * ) ;
virtual void 		before_row_change(void);
	private:
	hk_kdefinddialog* p_finddialog;
	bool		  p_findfirstview;
	QHBoxLayout* hbottomlayout;
	QHBoxLayout* hdatalayout;
	QHBoxLayout* htoplayout;
	QVBoxLayout* vbasiclayout;
	hk_vheader*     vheader;
	hk_hheader*     hheader;
    	hk_kdesimplegrid* grid;
	hk_kderowselector* selector;
	QLabel*		statusbar;
        QPushButton* topleftbutton;
void	reposition(void);
}
;
#endif
