// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.5 $

#include "hk_kdeindexeditwindow.h"
#include "hk_kdeindexeditwindow.moc"

#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qtoolbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

static const char* const image0_data[] = { 
"32 32 58 1",
". c None",
"# c #000000",
"b c #000400",
"c c #080408",
"g c #080808",
"O c #080c08",
"f c #100c10",
"Z c #101010",
"H c #101410",
"p c #181418",
"j c #181818",
"S c #181c18",
"t c #202420",
"N c #313031",
"3 c #393839",
"1 c #414041",
"2 c #524c52",
"X c #525052",
"0 c #525552",
"W c #5a555a",
"M c #5a595a",
"e c #625d62",
"a c #626162",
"T c #6a696a",
"Y c #736d73",
"R c #737173",
"P c #737573",
"U c #7b797b",
"J c #838183",
"F c #838583",
"G c #8b858b",
"E c #8b898b",
"D c #8b8d8b",
"z c #948d94",
"A c #949194",
"B c #949594",
"L c #9c959c",
"K c #9c999c",
"d c #9c9d9c",
"i c #a49da4",
"x c #a4a1a4",
"v c #a4a5a4",
"Q c #aca5ac",
"w c #acaaac",
"u c #b4aeb4",
"q c #b4b6b4",
"h c #bdb6bd",
"I c #bdbabd",
"V c #c5bec5",
"m c #c5c2c5",
"k c #c5c6c5",
"r c #cdc6cd",
"n c #cdcacd",
"C c #d5d6d5",
"s c #dedede",
"l c #e6dee6",
"y c #e6e2e6",
"o c #f6f2f6",
"................................",
"................................",
"................................",
".........##.....................",
".........#ab....................",
".........cdef...................",
".........ghiaj..................",
".........fklmej.................",
".........fnolmaj................",
".........pqorsmej...............",
".........tuormlmaj..............",
".........#voqwwlmej.............",
".........#xyuzAwlmaj............",
".........#BCDEFAwlmej...........",
".........#ArEFEGAwlmaH..........",
".........#FIFFJGFKqlmeg.........",
".........#JwGFGELBwwMNO.........",
".........#PdJGFAKQPMNp..........",
".........#RzBALKwPMNS...........",
".........#TJBAKhPMNj............",
".........NaUKiVPWNS.............",
".........tMRKmPXNj..............",
".........HMYVRWNS...............",
".........Z0TTXNj................",
".........OXaWNS.................",
".........g12Nj..................",
".........b3NZ...................",
".........#Nc....................",
".........##.....................",
"................................",
"................................",
"................................"};

static const char* const image1_data[] = { 
"32 32 43 1",
". c None",
"# c #000000",
"F c #000400",
"L c #080408",
"O c #292829",
"M c #292c29",
"B c #312c31",
"G c #313031",
"N c #393439",
"H c #4a484a",
"a c #525052",
"e c #5a5d5a",
"h c #625d62",
"c c #626162",
"b c #626562",
"K c #737173",
"C c #7b797b",
"s c #838183",
"x c #838583",
"p c #8b858b",
"v c #8b898b",
"y c #8b8d8b",
"D c #948d94",
"r c #949194",
"E c #949594",
"J c #9c959c",
"m c #9c999c",
"w c #9c9d9c",
"z c #a49da4",
"o c #aca5ac",
"q c #acaaac",
"I c #b4aeb4",
"A c #b4b6b4",
"j c #bdbabd",
"l c #bdbebd",
"n c #c5bec5",
"u c #c5c2c5",
"g c #cdcecd",
"d c #ded6de",
"k c #eeeeee",
"t c #f6eef6",
"i c #f6f2f6",
"f c #ffffff",
"................................",
"................................",
"................................",
".....................##.........",
"....................#a#.........",
"...................#ba#.........",
"..................#cde#.........",
".................#efgh#.........",
"................#hfije#.........",
"...............#efklmh#.........",
"..............#hfinope#.........",
".............#efkjqrsh#.........",
"............#hftuqrvpe#.........",
"...........#cfknqwxpyh#.........",
"..........#cfinqzvpxre#.........",
".........#efkjAmxxsprh#.........",
".........#BmCsmrrvpxme#.........",
"..........#BcCsorryDEh#.........",
"...........FGHCxImJrJe#.........",
"............FBHCsjmmEh#.........",
".............FGHCsjmme#.........",
"..............FBHCCjEh#.........",
"...............FGHKCjeL.........",
"................FGHhbh#.........",
".................#GHhe#.........",
"..................#MHN#.........",
"...................#BO#.........",
"....................#O#.........",
".....................##.........",
"................................",
"................................",
"................................"};


/*
 *  Constructs a hk_kdeindexeditdialog which is a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'
 */
hk_kdeindexeditdialog::hk_kdeindexeditdialog( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl ), hk_dsvisible()
{
    QPixmap image0( ( const char** ) image0_data );
    QPixmap image1( ( const char** ) image1_data );
    if ( !name )
	setName( "hk_kdeindexeditdialog" );
    resize( 486, 245 );
    setCaption( hk_translate( "Index Edit - Table:"  ).c_str() );
    hk_kdeindexeditdialogLayout = new QHBoxLayout( this );
    hk_kdeindexeditdialogLayout->setSpacing( 6 );
    hk_kdeindexeditdialogLayout->setMargin( 11 );

    Layout4 = new QVBoxLayout;
    Layout4->setSpacing( 6 );
    Layout4->setMargin( 0 );
    hk_kdeindexeditdialogLayout->addLayout( Layout4 );

    TextLabel1_2 = new QLabel( this, "TextLabel1_2" );
    TextLabel1_2->setText( hk_translate( "Free fields:"  ).c_str() );
    Layout4->addWidget( TextLabel1_2 );

    dsfieldlist = new QListBox( this, "dsfieldlist" );
    dsfieldlist->setMinimumSize( QSize( 150, 200 ) );
    Layout4->addWidget( dsfieldlist );

    Layout7 = new QVBoxLayout;
    Layout7->setSpacing( 6 );
    Layout7->setMargin( 0 );
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding );
    Layout7->addItem( spacer );

    Layout2 = new QVBoxLayout;
    Layout2->setSpacing( 6 );
    Layout2->setMargin( 0 );

    addbutton = new QToolButton( this, "addbutton" );
//    addbutton->setText( tr( ""  ) );
    addbutton->setPixmap( image0 );
    Layout2->addWidget( addbutton );

    deletebutton = new QToolButton( this, "deletebutton" );
//    deletebutton->setText( tr( ""  ) );
    deletebutton->setPixmap( image1 );
    deletebutton->setEnabled(false);
    Layout2->addWidget( deletebutton );
    Layout7->addLayout( Layout2 );
    QSpacerItem* spacer_2 = new QSpacerItem( 20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding );
    Layout7->addItem( spacer_2 );
    hk_kdeindexeditdialogLayout->addLayout( Layout7 );

    Layout5 = new QVBoxLayout;
    Layout5->setSpacing( 6 );
    Layout5->setMargin( 0 );

    TextLabel2_2 = new QLabel( this, "TextLabel2_2" );
    TextLabel2_2->setText( hk_translate( "Used fields:"  ).c_str() );
    Layout5->addWidget( TextLabel2_2 );

    indexfieldlist = new QListBox( this, "ListBox3" );
    indexfieldlist->setMinimumSize( QSize( 150, 200 ) );
    Layout5->addWidget( indexfieldlist );
    hk_kdeindexeditdialogLayout->addLayout( Layout5 );

    Layout13 = new QVBoxLayout;
    Layout13->setSpacing( 6 );
    Layout13->setMargin( 0 );

    Layout11 = new QVBoxLayout;
    Layout11->setSpacing( 6 );
    Layout11->setMargin( 0 );

    TextLabel1 = new QLabel( this, "TextLabel1" );
    TextLabel1->setText( hk_translate( "Indexname:"  ).c_str() );
    Layout11->addWidget( TextLabel1 );

    indexnamefield = new QLineEdit( this, "indexnamefield" );
    Layout11->addWidget( indexnamefield );
    Layout13->addLayout( Layout11 );

    Layout12 = new QHBoxLayout;
    Layout12->setSpacing( 6 );
    Layout12->setMargin( 0 );

    TextLabel2 = new QLabel( this, "TextLabel2" );
    TextLabel2->setText( hk_translate( "Unique"  ).c_str() );
    Layout12->addWidget( TextLabel2 );

    uniquefield = new QCheckBox( this, "uniquefield" );
//    uniquefield->setText( tr( ""  ) );
    uniquefield->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, uniquefield->sizePolicy().hasHeightForWidth() ) );
    Layout12->addWidget( uniquefield );
    Layout13->addLayout( Layout12 );
    QSpacerItem* spacer_3 = new QSpacerItem( 20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding );
    Layout13->addItem( spacer_3 );

    ButtonGroup7 = new QButtonGroup( this, "ButtonGroup7" );
//    ButtonGroup7->setTitle( tr( ""  ) );
    ButtonGroup7->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)4, (QSizePolicy::SizeType)5, ButtonGroup7->sizePolicy().hasHeightForWidth() ) );
    ButtonGroup7->setMaximumSize( QSize( 150, 32767 ) );
    ButtonGroup7->setColumnLayout(0, Qt::Vertical );
    ButtonGroup7->layout()->setSpacing( 0 );
    ButtonGroup7->layout()->setMargin( 0 );
    ButtonGroup7Layout = new QVBoxLayout( ButtonGroup7->layout() );
    ButtonGroup7Layout->setAlignment( Qt::AlignTop );
    ButtonGroup7Layout->setSpacing( 6 );
    ButtonGroup7Layout->setMargin( 11 );

    storebutton = new QPushButton( ButtonGroup7, "storebutton" );
    storebutton->setText( hk_translate( "OK"  ).c_str() );
    storebutton->setEnabled( FALSE );
    ButtonGroup7Layout->addWidget( storebutton );

    exitbutton = new QPushButton( ButtonGroup7, "exitbutton" );
    exitbutton->setText( hk_translate( "Exit"  ).c_str() );
    ButtonGroup7Layout->addWidget( exitbutton );
    Layout13->addWidget( ButtonGroup7 );
    hk_kdeindexeditdialogLayout->addLayout( Layout13 );

    // signals and slots connections
    connect( addbutton, SIGNAL( clicked() ), this, SLOT( addbutton_clicked() ) );
    connect( deletebutton, SIGNAL( clicked() ), this, SLOT( deletebutton_clicked() ) );
    connect( storebutton, SIGNAL( clicked() ), this, SLOT( okbutton_clicked() ) );
    connect( exitbutton, SIGNAL( clicked() ), this, SLOT( exitbutton_clicked() ) );
    connect( uniquefield, SIGNAL( stateChanged(int) ), this, SLOT( check_enablebuttons() ) );
    connect( indexnamefield, SIGNAL( textChanged(const QString&)), this, SLOT( check_enablebuttons() ) );
    p_changed=false;
}

/*
 *  Destroys the object and frees any allocated resources
 */
hk_kdeindexeditdialog::~hk_kdeindexeditdialog()
{
    // no need to delete child widgets, Qt does it all for us
}

void hk_kdeindexeditdialog::addbutton_clicked()
{

    indexfieldlist->insertItem(dsfieldlist->currentText(),indexfieldlist->currentItem()+1);
    dsfieldlist->removeItem(dsfieldlist->currentItem());
   check_enablebuttons();
   listentries_changed();

}

void hk_kdeindexeditdialog::deletebutton_clicked()
{
    dsfieldlist->insertItem(indexfieldlist->currentText(),dsfieldlist->currentItem()+1);
    indexfieldlist->removeItem(indexfieldlist->currentItem());
check_enablebuttons();
listentries_changed() ;
}

void hk_kdeindexeditdialog::exitbutton_clicked()
{
 close();
}

void hk_kdeindexeditdialog::okbutton_clicked()
{
   list<hk_string> f;
   unsigned int n=0;
   while (n<indexfieldlist->count())
   {
	f.insert(f.end(),indexfieldlist->text(n).latin1());
    	n++;
   }
 if (datasource()!=NULL)

     {
       if (datasource()->alter_index(indexnamefield->text().latin1(),uniquefield->isChecked(),f))
       close();
       else show_warningmessage(hk_translate("Index could not be altered"));
     }
 else close();
}

void hk_kdeindexeditdialog::check_enablebuttons(void)
{
    storebutton->setEnabled( indexnamefield->text().length()>0 && indexfieldlist->count()>0);
    p_changed=true;


}

void hk_kdeindexeditdialog::set_indexvalues(const hk_string& name,bool unique,list<hk_string>& fields,bool newindex)
{
 indexnamefield->setText(name.c_str());
 indexnamefield->setEnabled(newindex);
 uniquefield->setChecked(unique);
 list<hk_string>::iterator it=fields.begin();
 bool idxbuttonenabled=false;
 while (it!=fields.end())
 {
  indexfieldlist->insertItem((*it).c_str());
  idxbuttonenabled=true;
  it++;
 }
 if (datasource()==NULL) {return;}
 list<hk_column*>* cols=datasource()->columns();
 if (cols==NULL)
 	{
	 return;
	}
 bool fieldbuttonenabled=false;
 list<hk_column*>::iterator cit=cols->begin();
 while (cit!=cols->end())
 {
  if (!in_list((*cit)->name(),fields)&&(*cit)->is_notnull())
  {
    dsfieldlist->insertItem((*cit)->name().c_str());
    fieldbuttonenabled=true;
  }
  cit++;
 }
 dsfieldlist->setSelected(0,true);
 indexfieldlist->setSelected(0,true);
 deletebutton->setEnabled(idxbuttonenabled);
 addbutton->setEnabled(fieldbuttonenabled);

}

bool  hk_kdeindexeditdialog::in_list(const hk_string& f,list<hk_string>& l)
{
 list<hk_string>::iterator it=l.begin();
 while ( it!=l.end())
 {
  if ((*it)==f)return true;
  it++;
 }
 return false;
}

void hk_kdeindexeditdialog::before_source_vanishes(void)
{
 close();
}

void hk_kdeindexeditdialog::listentries_changed(void)
{
    addbutton->setEnabled(dsfieldlist->count()>0);
    deletebutton->setEnabled(indexfieldlist->count()>0);

}
