// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.3 $
#include "hk_kdelabel.h"
#include "hk_kdesimpleform.h"
#include <qapplication.h>

hk_kdelabel::hk_kdelabel(hk_kdesimpleform* form):QLabel(form), hk_label(form)
{
#ifdef HK_DEBUG
hkdebug("hk_kdelabel::hk_kdelabel");
#endif
  set_label("");
}


void	hk_kdelabel::widget_specific_label_changed(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdelabel::widget_specific_label_changed");
#endif
   if (label().size()>0)setText(label().c_str());
   else setText(hk_translate("label").c_str());
}

bool hk_kdelabel::widget_specific_coordinates(uint px,uint py,uint pwidth,uint pheight)
{
#ifdef HK_DEBUG
hkdebug("kdelabel::widget_specific_coordinates");
#endif
	setGeometry(px,py,pwidth,pheight);
	qApp->processEvents();

 return true;
}

void hk_kdelabel::resizeEvent ( QResizeEvent * event )
{
#ifdef HK_DEBUG
hkdebug("kdelabel::resizeEvent");
#endif
  QLabel::resizeEvent(event);
  reposition();

}


void  hk_kdelabel::moveEvent ( QMoveEvent * event)
{
#ifdef HK_DEBUG
hkdebug("kdelabel::resizeEvent");
#endif
    QLabel::moveEvent(event);
    reposition();
}



void hk_kdelabel::reposition(void)
{
#ifdef HK_DEBUG
hkdebug("kdelabel::reposition");
#endif
  if (p_form==NULL ||p_setcoordinates==true) return;
  p_setwidgetcoordinates=true;
    unsigned int ppx=p_form->horizontal2relativ(QLabel::x());
    unsigned int ppy=p_form->vertical2relativ(QLabel::y());
    unsigned int pph=p_form->vertical2relativ(QLabel::height(),p_dynamicheight);
    unsigned int ppw=p_form->horizontal2relativ(QLabel::width(),p_dynamicwidth);
    set_size(ppx,ppy,ppw,pph,p_dynamicwidth,p_dynamicheight);
  p_setwidgetcoordinates=false;
}

void hk_kdelabel::widget_specific_font_changed(void)
{
    setFont(QFont(p_font.c_str(),p_fontsizeint));
}
