// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.19 $
#include <hk_kdelineedit.h>
#include <hk_kdelineedit.moc>
#include <qkeycode.h>




hk_kdelineedit::hk_kdelineedit(QWidget* wid,hk_form* form)
	:KLineEdit(wid)
	,hk_dslineedit(form)
{
	QObject::connect(this,SIGNAL(textChanged(const QString& )),this,SLOT(slot_data_changed()));
#ifdef HK_DEBUG
	hkclassname("hk_kdelineedit");
hkdebug("hk_kdelineedit::hk_kdelineedit");
#endif
	p_widget_specific_row_change=true;
	setEnabled(false);
}


hk_kdelineedit::~hk_kdelineedit()
{
#ifdef HK_DEBUG
hkdebug("kdelineedit::destructor");
#endif
      p_widget_specific_row_change=true;

}

void hk_kdelineedit::keyPressEvent( QKeyEvent * e )
{
  if (e->key()==Key_Return)
  {
   if (e->state()&ControlButton)
	focusNextPrevChild(false);
   else
	focusNextPrevChild(true);

  }
  else
  {
     if (column()!=NULL)
       if (column()->is_readonly())
       {
       switch (e->key())
       {
        case Key_Left:
        case Key_Right:
        case Key_Home:
        case Key_End:
        case Key_Return: break;
        default: return;
       }
       }
     QLineEdit::keyPressEvent(e);
  }
}



void hk_kdelineedit::slot_data_changed(void)
{
 	#ifdef HK_DEBUG
 	hkdebug("kdelineedit::slotDataChanged");
 	#endif
 	if (!p_widget_specific_row_change)
 	{
 	#ifdef HK_DEBUG
 	hkdebug("kdelineedit::data has changed!");
 	#endif
 	 if (column()!=NULL)
 	 {
 	#ifdef HK_DEBUG
 	hkdebug("kdelineedit::data will be updated");
 	#endif
 	   column()->set_asstring(text().latin1());
 	 }
 	}
}


bool hk_kdelineedit::widget_specific_coordinates(uint px,uint py,uint pwidth,uint pheight)
{
#ifdef HK_DEBUG
hkdebug("kdelineedit::widget_specific_coordinates");
#endif
	setGeometry(px,py,pwidth,pheight);
	qApp->processEvents();

 return true;
}

bool hk_kdelineedit::widget_specific_row_change(void)
{
#ifdef HK_DEBUG
hkdebug("kdelineedit::widget_specific_row_change");
#endif
	hk_column* c=column();
  p_widget_specific_row_change=true;
  if (datasource()!=NULL)
	if (c!=NULL)
    			{
      				setText(c->asstring().c_str());
    			}



 p_widget_specific_row_change=false;
  return true;
}


void hk_kdelineedit::widget_specific_enable_disable()
{
#ifdef HK_DEBUG
hkdebug("kdelineedit::widget_specific_enable_disable");
#endif
 if ((datasource()!=NULL)&&(column()!=NULL))
 {
  #ifdef HK_DEBUG
hkdebug("kdelineedit::if ((datasource()!=NULL)&&(column()!=NULL))");
#endif

 	if (datasource()->is_enabled()>0)
 	{
 	setEnabled(true);
 	widget_specific_row_change();
 	}
 	else setEnabled(false);
 }
 else
   {
     setEnabled(false);
     setText("");
   }

}


bool hk_kdelineedit::datasource_disable()
{
bool erg=hk_dsdatavisible::datasource_disable();
 widget_specific_enable_disable();
return erg;
}

bool hk_kdelineedit::datasource_enable()
{
#ifdef HK_DEBUG
hkdebug("kdelineedit::datasource_enable");
#endif
bool erg=hk_dsdatavisible::datasource_enable();
 widget_specific_enable_disable();
return erg;
}

void hk_kdelineedit::datasource_delete(void)
{
	setText("");
	hk_dsdatavisible::datasource_delete();

}
void	hk_kdelineedit::widget_specific_insert_mode(void)
{
//  widget_specific_row_change();
  blockSignals(true);
  setText(use_defaultvalue()?defaultvalue().c_str():"");
  blockSignals(false);
}

void hk_kdelineedit::resizeEvent ( QResizeEvent * event )
{
#ifdef HK_DEBUG
hkdebug("kdelineedit::resizeEvent");
#endif
  KLineEdit::resizeEvent(event);
  reposition();

}


void  hk_kdelineedit::moveEvent ( QMoveEvent * event)
{
#ifdef HK_DEBUG
hkdebug("kdelineedit::resizeEvent");
#endif
    KLineEdit::moveEvent(event);
    reposition();
}

void hk_kdelineedit::reposition(void)
{
#ifdef HK_DEBUG
hkdebug("kdelineedit::reposition");
#endif
  if (p_form==NULL ||p_setcoordinates==true) return;
  p_setwidgetcoordinates=true;
    unsigned int ppx=p_form->horizontal2relativ(KLineEdit::x());
    unsigned int ppy=p_form->vertical2relativ(KLineEdit::y());
    unsigned int pph=p_form->vertical2relativ(KLineEdit::height(),p_dynamicheight);
    unsigned int ppw=p_form->horizontal2relativ(KLineEdit::width(),p_dynamicwidth);
    set_size(ppx,ppy,ppw,pph,p_dynamicwidth,p_dynamicheight);
  p_setwidgetcoordinates=false;
}

void hk_kdelineedit::widget_specific_font_changed(void)
{
    setFont(QFont(p_font.c_str(),p_fontsizeint));
}
