// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************

#ifndef HK_KDEMEMO_H
#define HK_KDEMEMO_H
#include <hk_dsmemo.h>
#include <keditcl.h>
/**
*
*@short KDE Widget to edit/display long data like text in a field.
*@version $Revision: 1.5 $
*@author Horst Knorr (hk_classes@knorrnet.de)

*Just set the datasource and the column (defined in the parent class @ref hk_dsdatavisible).
*/

class hk_kdememo: public KEdit,public hk_dsmemo

{Q_OBJECT
	public:
 	hk_kdememo(QWidget* wid,hk_form* f=NULL);
 	~hk_kdememo();
	protected:
virtual bool	widget_specific_coordinates(uint px,uint py,uint pwidth,uint pheight);
virtual bool	widget_specific_row_change(void);
virtual void	widget_specific_insert_mode(void);
bool	datasource_disable(void);
bool	datasource_enable(void);
void 	datasource_delete(void);
virtual void	widget_specific_font_changed(void);
virtual void resizeEvent (QResizeEvent *);
virtual void  moveEvent ( QMoveEvent * ) ;
void   keyPressEvent ( QKeyEvent * e );
	protected slots:
void	 slot_data_changed(void);
void 	before_row_change(void);
void	before_store_changed_data(void);
	private:
void	reposition(void);
	bool p_widget_specific_row_change;
void	widget_specific_enable_disable(void);
bool 	has_changed;

};
#endif
