// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.6 $

#include <hk_kdemessages.h>
#include <kmessagebox.h>
#include <hk_kdepassworddialog.h>
#include <kapp.h>
#include <kglobal.h>
#include <klocale.h>
#include <qinputdialog.h>
#include "hk_kdedriverdialog.h"
#include <hk_classes.h>
void hk_kdewarning(const hk_string& w)
{
  KMessageBox::information(0,w.c_str(),hk_class::hk_translate("Warning").c_str(),0,0);
}


bool hk_kdeyesno_dialog(const hk_string& w,bool )
{
  int ret;
  QString a=hk_class::hk_translate("Please decide").c_str();
  ret=KMessageBox::questionYesNo(0,w.c_str(),a,0,0,0);
//  if 	(default_return) ret=KMessageBox::questionYesNo(0,a,w,0,0,0);
//  	else		ret=KMessageBox::questionYesNo(0,a,w,KMessageBox::DB_SECOND,0,0);
 if (ret==3) 	return true;
 			else	return false;
}

hk_string hk_kdestringvaluedialog(const hk_string& st)
{
  bool ok;
 QString text = QInputDialog::getText( hk_class::hk_translate( "Make an input" ).c_str(), hk_class::hk_translate(st).c_str(), QString::null, &ok, NULL );
 if (ok) return text.latin1();
 else return "";

}

void set_kdestandarddialogs(void)
{
    hk_class::set_yesnodialog(&hk_kdeyesno_dialog);
    hk_class::set_warningmessage(&hk_kdewarning);
    hk_connection::set_passworddialog(&hk_kdepassworddlg);
    hk_drivermanager::set_driverselectdialog( &hk_kdedriverselectdialog);
    hk_drivermanager::set_stringvaluedialog( &hk_kdestringvaluedialog);
    hk_drivermanager::set_translatefunction(&hk_kdetranslate);
}


void hk_kdepassworddlg(struct_connectionfields* c,int needs)
{
  hk_kdepassworddialog* d=new hk_kdepassworddialog(0,0,c,needs);
  d->exec();
  delete d;

}

hk_string hk_kdetranslate(const hk_string& t)
{
 QString erg=i18n(t.c_str());
 return (erg.latin1());
}

hk_string hk_kdedriverselectdialog(void)
{
  hk_kdedriverdialog* c = new hk_kdedriverdialog();
  c->exec();
  hk_string p=c->drivername();
  delete c;
  return p;
}
