// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.2 $

#include <hk_kdepassworddialog.h>
#include <klocale.h>
#include <hk_kdepassworddialog.moc>
#include <qkeycode.h>
#include <hk_class.h>

class dialogedit:public QLineEdit
{
  public:
  dialogedit(QWidget* wid,const char*t=0): QLineEdit(wid,t){}
  protected:
void   keyPressEvent ( QKeyEvent * e );
};
void dialogedit::keyPressEvent( QKeyEvent * e )
{
  if (e->key()==Key_Return)
  {
   if (e->state()&ControlButton)
	focusNextPrevChild(false);
   else
	focusNextPrevChild(true);

  }
  else QLineEdit::keyPressEvent(e);
}
class dialogbool:public QCheckBox
{
  public:
  dialogbool(QWidget* wid,const char*t=0): QCheckBox(wid,t){}
  protected:
void   keyPressEvent ( QKeyEvent * e );
};
void dialogbool::keyPressEvent( QKeyEvent * e )
{
  if (e->key()==Key_Return)
  {
   if (e->state()&ControlButton)
	focusNextPrevChild(false);
   else
	focusNextPrevChild(true);

  }
  else QCheckBox::keyPressEvent(e);
}

class  button:public QPushButton
{
  public:
  button(QWidget* wid=0,const char*t=0 ): QPushButton(wid,t){}
  protected:
void   keyPressEvent ( QKeyEvent * e );

};

void button::keyPressEvent( QKeyEvent * e )
{
  if (e->key()==Key_Return)
  {
   emit (clicked());

  }
  else QPushButton::keyPressEvent(e);
}

hk_kdepassworddialog::hk_kdepassworddialog(QWidget* p,const char* name,struct_connectionfields*fields,int needs)
:QDialog(p,name,true)
{
    setMinimumSize( QSize( 300, 250 ) );
 setCaption(hk_class::hk_translate("Password Dialog").c_str());
  bool focus_set=false;
  p_needs=needs;
  p_fields=fields;
   header=new QLabel(this,"headerlabel");
  header->setText(hk_class::hk_translate("Required login infos:").c_str());
   gesamtlayout = new QVBoxLayout(this);
   headerlayout = new QHBoxLayout(this);
   textlayout = new QVBoxLayout(this);
   fieldlayout = new QVBoxLayout(this);
   datalayout = new QHBoxLayout(this);
   buttonlayout = new QHBoxLayout(this);
    gesamtlayout->setSpacing( 10 );
    gesamtlayout->setMargin( 20 );
    headerlayout->setSpacing( 6 );
    headerlayout->setMargin( 10);
    textlayout->setSpacing( 15 );
    textlayout->setMargin( 10 );
    fieldlayout->setSpacing( 15 );
    fieldlayout->setMargin( 10 );
    datalayout->setSpacing( 6 );
    datalayout->setMargin( 0 );
    buttonlayout->setSpacing( 6 );
    buttonlayout->setMargin( 0 );
    QSpacerItem* hspacer1=new QSpacerItem(20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);
   QSpacerItem* vspacer1=new QSpacerItem(5, 5, QSizePolicy::Minimum, QSizePolicy::Expanding);
   QSpacerItem* vspacer2=new QSpacerItem(20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding);
   headerlayout->addWidget(header);
   gesamtlayout->addItem(vspacer1);
   gesamtlayout->addItem(headerlayout);
   gesamtlayout->addItem(datalayout);
   gesamtlayout->addItem(vspacer2);
   gesamtlayout->addItem(buttonlayout);

   datalayout->addItem(textlayout);
   datalayout->addItem(hspacer1);
   datalayout->addItem(fieldlayout);

  if (needs&needs_host)
  {
  	hostlabel= new QLabel(this,"hostlabel");
  	hostlabel->setText(hk_class::hk_translate("Host:").c_str());
	textlayout->addWidget(hostlabel);
  	hostedit= new dialogedit(this,"hostedit");
	fieldlayout->addWidget(hostedit);
	if (!focus_set)
  	{
  	focus_set=true;
  	hostedit->setFocus();
  	}
  if (fields!=0)hostedit->setText(fields->host.c_str());
  }
   else
   {
    hostlabel=NULL;
    hostedit=NULL;
   }

  if (needs&needs_username)
  {
  	userlabel= new QLabel(this,"userlabel");
  	userlabel->setText(hk_class::hk_translate("User:").c_str());
	textlayout->addWidget(userlabel);
	useredit= new dialogedit(this,"useredit");
	fieldlayout->addWidget(useredit);

   if (fields!=0)useredit->setText(fields->user.c_str());
   	if (!focus_set)
  	{
  	focus_set=true;
  	useredit->setFocus();
  	}

  }
   else
   {
    userlabel=NULL;
    useredit=NULL;
   }

  if (needs&needs_password)
  {
  	passwordlabel= new QLabel(this,"passwordlabel");
  	passwordlabel->setText(hk_class::hk_translate("Password:").c_str());
	textlayout->addWidget(passwordlabel);
	passwordedit= new dialogedit(this,"passwordedit");
  	passwordedit->setEchoMode(dialogedit::Password);
	fieldlayout->addWidget(passwordedit);
	if (!focus_set)
  	{
  	focus_set=true;
  	passwordedit->setFocus();
  	}
  }
     else
   {
    passwordlabel=NULL;
    passwordedit=NULL;
   }

  if (needs&needs_port)
  {
  	portlabel= new QLabel(this,"portlabel");
  	portlabel->setText(hk_class::hk_translate("TCP Port:").c_str());
	textlayout->addWidget(portlabel);
	portedit= new dialogedit(this,"portedit");
	fieldlayout->addWidget(portedit);
  if (fields!=0)portedit->setText(fields->port.c_str());
  	if (!focus_set)
  	{
  	focus_set=true;
  	portedit->setFocus();
  	}
  }
     else
   {
    passwordlabel=NULL;
    passwordedit=NULL;
   }


  if (needs&needs_sqldelimiter)
  {
  	sqldelimiterlabel= new QLabel(this,"sqldelimiterlabel");
  	sqldelimiterlabel->setText(hk_class::hk_translate("SQL Delimiter:").c_str());
	textlayout->addWidget(sqldelimiterlabel);
	sqldelimiteredit= new dialogedit(this,"sqldelimiteredit");
	fieldlayout->addWidget(sqldelimiteredit);
  if (fields!=0)sqldelimiteredit->setText(fields->sql_delimiter.c_str());
  	if (!focus_set)
  	{
  	focus_set=true;
  	portedit->setFocus();
  	}

  }
  else
   {
    sqldelimiterlabel=NULL;
    sqldelimiteredit=NULL;
   }

      savesettingslabel= new QLabel(this,"savesettingslabel");
//      savesettingslabel->setText(hk_class::hk_translate("Save settings").c_str());
      textlayout->addWidget(savesettingslabel);
      savesettings=new dialogbool(this,"savesettings");
      savesettings->setText(hk_class::hk_translate("Save settings").c_str());
      fieldlayout->addWidget(savesettings);

  ok_button= new button(this,"OKButton");
  ok_button->setText(hk_class::hk_translate("OK").c_str());
  buttonlayout->addWidget(ok_button);
   QSpacerItem* hspacer2=new QSpacerItem(20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);
  buttonlayout->addItem(hspacer2);
  cancel_button= new button(this,"CancelButton");
//  cancel_button->setGeometry(leftedit,top+offset+2*v_space,buttonsize,buttonheight);
  cancel_button->setMinimumSize(0,0);
  cancel_button->setText(hk_class::hk_translate("Cancel").c_str());
  buttonlayout->addWidget(cancel_button);
  ;


  connect( ok_button, SIGNAL(clicked()), SLOT(ok_buttonclicked()) );
  connect( cancel_button, SIGNAL(clicked()), SLOT(cancel_buttonclicked()) );
}


hk_kdepassworddialog::~hk_kdepassworddialog()
{
	delete ok_button;
	delete cancel_button;
	delete hostlabel;
	delete hostedit;
	delete userlabel;
	delete useredit;
	delete passwordlabel;
	delete passwordedit;
	delete sqldelimiterlabel;
	delete sqldelimiteredit;

}


void hk_kdepassworddialog::ok_buttonclicked()
{
  if (p_fields!=0)
  {
    if (p_needs&needs_host) p_fields->host=hostedit->text();
//    cout <<"host: "<<p_fields->host<<endl;
    if (p_needs&needs_username) p_fields->user=useredit->text();
//    cout <<"user: "<<p_fields->user<<endl;
    if (p_needs&needs_password) p_fields->password=passwordedit->text();
//    cout <<"password: "<<p_fields->password<<endl;
    if (p_needs&needs_sqldelimiter) p_fields->sql_delimiter=sqldelimiteredit->text();
//    cout <<"sqldelimiter:"<<p_fields->sql_delimiter<<endl;
    if (p_needs&needs_port) p_fields->port=portedit->text();
//    cout <<"Port:"<<p_fields->port<<endl;
    p_fields->cancel=false;
    p_fields->save=savesettings->isChecked();
  }
  accept();

}

void hk_kdepassworddialog::cancel_buttonclicked()
{
  if (p_fields!=0) p_fields->cancel=true;
  reject();
}

