// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************

#ifndef HK_KDEPROPERTY_H
#define HK_KDEPROPERTY_H
#include "hk_kdepropertybase.h"
#include <hk_class.h>
class QFontDatabase;
class hk_kdesimpleform;
class hk_kdeproperty : public hk_kdepropertyeditorbase,public hk_class
{
    Q_OBJECT

public:
    hk_kdeproperty( hk_kdesimpleform* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~hk_kdeproperty();

public slots:
    void action_changes();
    void actionobject_changes();
    void data_changes();
    void format_changes();
    void set_object(hk_visible*);
    void focus_resized(void);
    void set_datasourcelist(void);
virtual void add_formdatasource();
virtual void add_listformdatasource();
    void datasource_selected();
    void listdatasource_selected();
    void set_actionobjectlist(void);
private:
	hk_visible* p_visible;
    // change the propertyfields when hk_visible changes
    void set_visible(void);
    void set_dsvisible(void);
    void set_dsdatavisible(void);
    void set_gridvisible(void);
    void set_button(void);

    //change values in hk_visible when the property fields changes
    void set_objectvisible();
    void set_objectdsvisible(void);
    void set_objectdsdatavisible(void);
    void set_objectaction(void);
    QFontDatabase* p_fontdatabase;
    hk_kdesimpleform* p_form;
};

#endif // HK_KDEPROPERTY_H
