// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.29 $
#include "hk_kdesimpleform.h"
#include "hk_kdeform.h"
#include "hk_kdegrid.h"
#include "hk_kdelineedit.h"
#include "hk_kdeboolean.h"
#include "hk_kdesimpleform.moc"
#include "hk_kderowselector.h"
#include "hk_kdememo.h"
#include "hk_kdebutton.h"
#include "hk_kdecombobox.h"
#include "hk_kdeformfocus.h"
#include "hk_kdeproperty.h"
#include "hk_kdelabel.h"
#include "hk_visible.h"
#include "hk_dsvisible.h"
#include <qkeycode.h>
#include <qpopupmenu.h>
#include <qfocusdata.h>

hk_kdesimpleform::hk_kdesimpleform(QWidget* wid) :QWidget(wid),hk_form()
{
#ifdef HK_DEBUG
 hkclassname("hk_kdesimpleform");
 hkdebug("hk_kdesimpleform::hk_kdesimpleform");
#endif
//	setBackgroundMode(PaletteMid);
   setFixedWidth(p_actualwidth);
   setFixedHeight(p_actualheight);
   p_autoclose=true;
   p_field2create=other;
   p_property=NULL;
   p_focus = new hk_kdeformfocus(this);
   p_createflag=false;
   p_controlbutton=false;
   setFocusPolicy(StrongFocus);
   setFocus();
   p_kdeform=NULL;
   p_popup=NULL;

}

hk_kdesimpleform::~hk_kdesimpleform(void)
{
#ifdef HK_DEBUG
 hkdebug("hk_kdesimpleform::~hk_kdesimpleform");
#endif
   delete p_focus;
   delete p_property;
}

hk_dsgrid*	hk_kdesimpleform::widget_specific_new_grid(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::widget_specific_new_grid(void)");
#endif
	hk_kdegrid* g=new hk_kdegrid(this,0,0,this);
	if (g==NULL) return NULL;
	g->show();
	#ifdef HK_DEBUG
	g->hkclassname("simplegrid");
	#endif
	return g;
}

hk_dslineedit* 		hk_kdesimpleform::widget_specific_new_lineedit(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::widget_specific_new_lineedit(void)");
#endif
	hk_kdelineedit* l=new hk_kdelineedit(this,this);
	l->show();
	#ifdef HK_DEBUG
	l->hkclassname("lineedit");
	#endif
	set_focus(l);
	return l;
}

hk_dsboolean* 		hk_kdesimpleform::widget_specific_new_bool(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::widget_specific_new_bool(void)");
#endif
	hk_kdeboolean* b=new hk_kdeboolean(this,this);
	b->show();
	#ifdef HK_DEBUG
        b->hkclassname("bool");
	#endif
	b->setBackgroundMode(backgroundMode());
	set_focus(b);
	return b;
}

hk_dscombobox* 		hk_kdesimpleform::widget_specific_new_combobox(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::widget_specific_new_combobox(void)");
#endif
	hk_kdecombobox* c=new hk_kdecombobox(this,this);
	c->show();
	#ifdef HK_DEBUG
	c->hkclassname("combobox");
	#endif
	set_focus(c);
	return c;
}

hk_dsmemo* 		hk_kdesimpleform::widget_specific_new_memo(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::widget_specific_new_memo(void)");
#endif
	hk_kdememo* m=new hk_kdememo(this,this);
	m->show();
	#ifdef HK_DEBUG
	  m->hkclassname("memo");
	#endif
	return m;
}

hk_button* 		hk_kdesimpleform::widget_specific_new_button(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::widget_specific_new_button(void)");
#endif
	hk_kdebutton* b=new hk_kdebutton(this,this);
	b->show();
	#ifdef HK_DEBUG
	  b->hkclassname("button");
	#endif
	return b;
}


hk_dsrowselector*	hk_kdesimpleform::widget_specific_new_rowselector(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::widget_specific_new_rowselector(void)");
#endif
	hk_kderowselector* s=new hk_kderowselector(this,this);
	s->show();
	#ifdef HK_DEBUG
	  s->hkclassname("rowselector");
	#endif
	return s;
}


hk_label* hk_kdesimpleform::widget_specific_new_label(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::widget_specific_new_lineedit(void)");
#endif
	hk_kdelabel* s=new hk_kdelabel(this);
	s->show();
	#ifdef HK_DEBUG
	   s->hkclassname("label");
	#endif
	s->setBackgroundMode(backgroundMode());
	return s;
}


void	hk_kdesimpleform::widget_specific_fieldresize(hk_visible* )
{

}

void	hk_kdesimpleform::widget_specific_formresize(void)
{
#ifdef HK_DEBUG
 hkdebug("hk_kdesimpleform::widget_specific_formresize");
#endif
   setFixedWidth(p_actualwidth);
   setFixedHeight(p_actualheight);
}


void hk_kdesimpleform::before_source_vanishes(void)
{
#ifdef HK_DEBUG
 hkdebug("hk_kdesimpleform::before_source_vanishes");
#endif
  hk_form::before_source_vanishes();

  if (p_autoclose)
    {
     if (parentWidget()!=NULL)
     {
      emit closeform();
     }
    }
}

void hk_kdesimpleform::database_has_vanished(void)
{
#ifdef HK_DEBUG
 hkdebug("hk_kdesimpleform::database_has_vanished");
#endif
  if (p_autoclose)
    {
     if (parentWidget()!=NULL)
     {
      emit closeform();
     }
    }
}

void 	hk_kdesimpleform::mousePressEvent(QMouseEvent* m)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::mousePressEvent");
#endif
  if (mode()==design)
  {
    switch (m->button())
    {
       case LeftButton:
  			{
  				emit mouseclick(m->pos());
				if (p_field2create!=other)create_field(m->pos());
				else
				{
				  clearfocus();
         if (p_property!=NULL) p_property->set_object(this);
				}
			break;
			}

      case RightButton:
			  {
     				mousemenu(m);
			  	break;
			  }
      default:		;
     }
  }
  QWidget::mousePressEvent(m);
}

void 	hk_kdesimpleform::mouseReleaseEvent(QMouseEvent* )
{
}


void hk_kdesimpleform::set_field2create(enum_visibletype v)
{
	p_field2create=v;

}

void hk_kdesimpleform::create_field(const QPoint& point)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::create_field");
#endif
   hk_visible* newfield=NULL;
   switch (p_field2create)
   {
      case lineedit : newfield = new_lineedit();
      			break;
      case textlabel : newfield = new_label();
      			break;
      case button : newfield = new_button();
      			break;
      case rowselector : newfield = new_rowselector();
      			break;
      case memo : newfield = new_memo();
      			break;
      case boolean : newfield = new_bool();
      			break;
      case grid : newfield = new_grid();
      			break;
      case combobox : newfield = new_combobox();
      			break;
      default:;

   }
   if (newfield!=NULL)
   	{
	   newfield->set_position((point.x()*10000)/QWidget::width(),(point.y()*10000)/QWidget::height());
	   if (newfield->type()==grid)
	     {

	       newfield->set_size((point.x()*10000)/QWidget::width(),(point.y()*10000)/QWidget::height(),3500,1500);
  	       QWidget* w=dynamic_cast <QWidget*>(newfield);
               if (w!=NULL)set_focus( w->parentWidget());
	     }
	 else	 set_focus(dynamic_cast <QWidget*>(newfield));
	}
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::create_field focus setzen");
#endif
  p_focus->set_positions();
  p_createflag=true;
  emit field_created();
  p_field2create=other;
}


void hk_kdesimpleform::paintEvent(QPaintEvent* e)
{
  if (mode()==hk_presentation::view)
  	{
		QWidget::paintEvent(e) ;
		return;
	}

    QPainter p(this);
    p.setClipRegion( e->rect() );
    p.setPen( colorGroup().background() );
    p.setPen( colorGroup().foreground() );
    for (int a=0; a<QWidget::width()/10+20; a++ )
    {
      for (int b=0; b<QWidget::height()/10+20;b++ )
	p.drawPoint(a*10,b*10);
    }


}

bool hk_kdesimpleform::eventFilter(QObject* object,QEvent* event)
{
   if (   mode()!=design
      	||!object->isWidgetType()
      )
      return QWidget::eventFilter(object,event);
   hk_visible* v = dynamic_cast <hk_visible*>(object);
   hk_visible* p = dynamic_cast <hk_visible*> ( ((QWidget*) object)->parentWidget() );
   if ((v==NULL&& p==NULL)|| dynamic_cast <hk_marker*>(object)!=NULL||!is_formobject((QWidget*) object))
   {
      return QWidget::eventFilter(object,event);
   }
   return formeventFilter(object,event);
}

bool hk_kdesimpleform::formeventFilter(QObject* object,QEvent* event)
{
#ifdef HK_DEBUG
//hkdebug("hk_kdesimpleform::formeventFilter");
#endif
   QWidget* widget= (QWidget*) object;
// check for special widget treatment

   if (dynamic_cast <hk_visible*>(object) == NULL)
   {
      widget = widget->parentWidget();
   }
   else
   {
      if (dynamic_cast <hk_kdesimplegrid*>(widget)!=NULL
      ||  dynamic_cast <hk_kdegrid*>(widget->parentWidget())!=NULL)
      widget= widget->parentWidget();


   }

   if (dynamic_cast <hk_kderowselector*>(widget)!=NULL)
   {
	if (dynamic_cast <hk_kdegrid*>(widget->parentWidget())!=NULL)
	widget = widget->parentWidget();
   }

// ENDE check for special widget treatment


   switch (event->type())
   {
       case QEvent::KeyPress    	:  {
						keyPressEvent((QKeyEvent*)event);
			   			break;
       			   		   };
       case QEvent::KeyRelease    	:  {
						keyReleaseEvent((QKeyEvent*)event);
			     			break;
       			  		   };
       case QEvent::MouseButtonPress    :  {

   						if (object==this)
   						{
						   if (((QMouseEvent*)event)->button() !=RightButton)
						   {
      						     mousePressEvent((QMouseEvent*) event);
      						     return true;
						   }
   						}
   						else
   						if (((QMouseEvent*)event)->button() ==LeftButton)
     						{  //select object
						   if ( dynamic_cast <QPopupMenu*>(object)) // i.e. a menu
						   return QWidget::eventFilter(object,event);

						   set_focus(widget);
	 					   if (widget!=NULL)p_focus->show();
     	 					   p_originalposition=mapFromGlobal(((QMouseEvent*)event)->globalPos());
	 					   return true;
     						}
   						else
      						if (((QMouseEvent*)event)->button() ==RightButton)
      						{
         					   mousemenu((QMouseEvent*)event);
	 					   return true;
      						}
			     			break;
       			   		   };
       case QEvent::MouseMove    	:  {
  						if (
						(((QMouseEvent*)event)->state() & LeftButton ) == LeftButton&&
						widget==p_focus->widget()
     						)
  						{
    						//move object
     						QPoint newpos=mapFromGlobal(((QMouseEvent*)event)->globalPos());
     						QPoint difference=p_originalposition-newpos;
     						p_originalposition=newpos;
     						if ( widget->x()-difference.x()<0) difference.setX(widget->x());
     						if ( widget->y()-difference.y()<0) difference.setY(widget->y());
     						if ( widget->x()+widget->width()-difference.x()>(signed)designwidth())
     						difference.setX(-(designwidth()-widget->x()-widget->width()));
     						if ( widget->y()+widget->height()-difference.y()>(signed)designheight())
     						difference.setY(-(designheight()-widget->y()-widget->height()));
     						widget->move(widget->x()-difference.x(),widget->y()-difference.y());
     						p_focus->set_positions();
     						p_property->focus_resized();
  						}
			     			break;
       			   		   };


        case QEvent::MouseButtonDblClick : return true;
       default				:;

   }

 return QWidget::eventFilter(object,event);


}


void hk_kdesimpleform::widget_specific_modechanges(enum_mode s)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::widget_specific_modechanges");
#endif
  list<hk_kdeformfocus*>::iterator it=p_multiplefocus.begin();
   if(s==design)
   {
     setFocusPolicy(StrongFocus);
     setFocus();
	qApp->installEventFilter(this);
	if (p_property==NULL)
	   {
	      p_property=new hk_kdeproperty(this,0,false);
	   }

	if (p_focus->widget()!=NULL)
	    p_property->set_object( dynamic_cast <hk_visible*> (p_focus->widget()));
	else p_property->set_object(this);
	while (it!=p_multiplefocus.end())
  	{

		hk_kdeformfocus* f=(*it);
     		f->show();
     		it++;
  	}
     p_focus->show();
     p_property->show();

   }
   else   // s!=design
   {
	qApp->removeEventFilter(this);
	while (it!=p_multiplefocus.end())
  	{
     	   	hk_kdeformfocus* f=(*it);
     		f->hide();
     		it++;
  	}
     p_focus->hide();
    if(p_property!=NULL) p_property->hide();
    setFocusPolicy(ClickFocus);

   }
}

void hk_kdesimpleform::widget_specific_after_loadform(void)
{
   clearfocus();
   qApp->processEvents();
}

void hk_kdesimpleform::clearmultiplefocus(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::clearmultiplefocus");
#endif
  list<hk_kdeformfocus*>::iterator it=p_multiplefocus.begin();
  while (it!=p_multiplefocus.end())
  {
     hk_kdeformfocus* f=(*it);
     it++;
     if (f!=p_focus) delete f;
  }
  p_multiplefocus.erase(p_multiplefocus.begin(),p_multiplefocus.end());
}

void hk_kdesimpleform::keyPressEvent ( QKeyEvent * event )
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::keyPressEvent");
#endif
  switch(event->key())
  {
   case Key_Control:  p_controlbutton=true;
   			break;
   case Key_Delete:   delete_widgets();
   			break;
   default	:     ;
  }
QWidget::keyPressEvent(event);

}

void hk_kdesimpleform::keyReleaseEvent ( QKeyEvent * event)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::keyReleaseEvent");
#endif
  if (event->key()==Key_Control)  p_controlbutton=false;
  QWidget::keyReleaseEvent(event);

}


void hk_kdesimpleform::clearfocus(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::clearfocus");
#endif
  if (p_focus!=NULL) p_focus->set_widget(NULL);
  p_controlbutton=false;
  clearmultiplefocus();
}

void hk_kdesimpleform::set_focus(QWidget*f)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::set_focus");
#endif
    if (f==NULL || f==this)
      {
	 clearfocus();
	 return;
      }

   if (p_controlbutton==true)
   {


   if (p_focus->widget()==f ) return;
  list<hk_kdeformfocus*>::iterator it=p_multiplefocus.begin();
  while (it!=p_multiplefocus.end())
  {
     hk_kdeformfocus* w=(*it);
     it++;
     if (w->widget()==f) return;
  }

  }
    if (p_controlbutton==true)
      {
	 p_multiplefocus.insert(p_multiplefocus.end(),p_focus);
	 hk_kdeformfocus* pf=p_focus;
   	 p_focus = new hk_kdeformfocus(this);
	 pf->repaint();
      }
    else clearmultiplefocus();
    p_focus->set_widget(f);
    hk_visible* v= dynamic_cast<hk_visible*>(f);
    if (p_property!=NULL)
       {
          QObject::connect(p_focus,SIGNAL(size_changed()),p_property,SLOT(focus_resized()));
          p_property->set_object(v);
       }

}

void hk_kdesimpleform::delete_widgets(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::delete_widgets");
#endif
QWidget* w=NULL;
QWidget* del=NULL;
  list<hk_kdeformfocus*>::iterator it=p_multiplefocus.begin();
  while (it!=p_multiplefocus.end())
  {
     hk_kdeformfocus* f=(*it);
     it++;
     w=f->widget();
     del=w;
     f->set_widget(NULL);
     hk_kdegrid* g=dynamic_cast <hk_kdegrid*>(w);
     if (g!=NULL) del=g->simplegrid();
     remove_visible(dynamic_cast <hk_visible*>(del));
     delete w;
  }
  w=p_focus->widget();
  del=w;
  p_focus->set_widget(NULL);
  hk_kdegrid* g=dynamic_cast <hk_kdegrid*>(w);
  if (g!=NULL) del=g->simplegrid();
  remove_visible(dynamic_cast <hk_visible*>(del));
  delete w;
  if (p_property!=NULL) p_property->set_object(this);
  clearfocus();
  set_has_changed();
}


void hk_kdesimpleform::mousemenu(QMouseEvent* m)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::mousemenu");
#endif

    if (p_popup!=NULL) return;
    p_popup=new QPopupMenu(this);
    if (p_multiplefocus.size()>0)
    {


    QPopupMenu* p_adjustsize =new QPopupMenu(this);
    QPopupMenu* p_align =new QPopupMenu(this);
    p_popup->insertItem( hk_class::hk_translate( "Adjust &size" ).c_str(),p_adjustsize,1 );
    p_popup->insertItem( hk_class::hk_translate( "&Align" ).c_str(),p_align,2 );

    p_adjustsize->insertItem( hk_class::hk_translate( "Minimum width" ).c_str(),3 );
    p_adjustsize->insertItem( hk_class::hk_translate( "Maximum width" ).c_str(),4 );
    p_adjustsize->insertItem( hk_class::hk_translate( "Minimum height" ).c_str(),5 );
    p_adjustsize->insertItem( hk_class::hk_translate( "Maximum height" ).c_str(),6 );
    p_adjustsize->insertItem( hk_class::hk_translate( "Minimum size" ).c_str(),7 );
    p_adjustsize->insertItem( hk_class::hk_translate( "Maximum size" ).c_str(),8 );

    p_align->insertItem( hk_class::hk_translate( "&Left" ).c_str(),9 );
    p_align->insertItem( hk_class::hk_translate( "&Right" ).c_str(),10 );
    p_align->insertItem( hk_class::hk_translate( "&Top" ).c_str(),11 );
    p_align->insertItem( hk_class::hk_translate( "&Bottom" ).c_str(),12);
    }

    if (p_focus->widget()!=NULL)
       p_popup->insertItem( hk_class::hk_translate( "&Delete" ).c_str(),13 );

    p_popup->insertItem( hk_class::hk_translate( "Show &property editor" ).c_str(),14 );
    p_popup->insertItem( hk_class::hk_translate( "&Save form" ).c_str(),15 );




    int r = p_popup->exec( m->globalPos() );
    switch (r)
    {
      case 3:		adjust_widgets(sminw);
			break;
      case 4:		adjust_widgets(smaxw);
			break;
      case 5:		adjust_widgets(sminh);
			break;
      case 6:		adjust_widgets(smaxh);
			break;
      case 7:		adjust_widgets(smins);
			break;
      case 8:		adjust_widgets(smaxs);;
			break;
      case 9:		adjust_widgets(al);
			break;
      case 10:		adjust_widgets(ar);
			break;
      case 11:		adjust_widgets(at);
			break;
      case 12:		adjust_widgets(ab);
			break;
      case 13:		delete_widgets();
			break;
      case 14:          {
			if (p_property==NULL)
	   		{
	      		  p_property=new hk_kdeproperty(this,0,false);
	   		}
      			if (p_property!=NULL)  p_property->show();
			break;
			}
      case 15:          {
      			save_form("",false);
			break;
			}
      default:;
    }

    delete p_popup;
    p_popup=NULL;


}

void hk_kdesimpleform::adjust_widgets(hk_kdesimpleform::enum_adjust s)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::adjust_widgets");
#endif
  int maxw=0;
  int maxh=0;
  int minw=90000;
  int minh=90000;
  int minx=90000;
  int miny=90000;
  int maxx=0;
  int maxy=0;
  list<hk_kdeformfocus*>::iterator it=p_multiplefocus.begin();
  while (it!=p_multiplefocus.end())
  {
     hk_kdeformfocus* f=(*it);
     it++;
     QWidget* w=f->widget();
     if  (maxw <w->width()) maxw=w->width();
     if  (maxh <w->height()) maxh=w->height();
     if  (minw >w->width()) minw=w->width();
     if  (minh >w->height()) minh=w->height();
     if  (minx >w->x()) minx=w->x();
     if  (maxx <w->x()+w->width()) maxx=w->x()+w->width();
     if  (miny >w->y()) miny=w->y();
     if  (maxy <w->y()+w->height()) maxy=w->y()+w->height();

  }
     QWidget* w=p_focus->widget();
     if (w==NULL)
        {
	  return;
	}
     if  (maxw <w->width()) maxw=w->width();
     if  (maxh <w->height()) maxh=w->height();
     if  (minw >w->width()) minw=w->width();
     if  (minh >w->height()) minh=w->height();
     if  (minx >w->x()) minx=w->x();
     if  (maxx <w->x()+w->width()) maxx=w->x()+w->width();
     if  (miny >w->y()) miny=w->y();
     if  (maxy <w->y()+w->height()) maxy=w->y()+w->height();

  it=p_multiplefocus.begin();
  while (it!=p_multiplefocus.end())
  {
     hk_kdeformfocus* f=(*it);
     it++;
     resize_widget(f->widget(),s,minw,maxw,minh,maxh,minx,maxx,miny,maxy);
   }

   resize_widget(p_focus->widget(),s,minw,maxw,minh,maxh,minx,maxx,miny,maxy);
   repaint_focus();
}

void hk_kdesimpleform::resize_widget(QWidget* w,enum_adjust s,int minw,int maxw,int minh,int maxh, int minx, int maxx, int miny, int maxy)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::resize_widget");
#endif
  	switch (s)
  	{
  	   case hk_kdesimpleform::sminw :  w->setGeometry(w->x(),w->y(),minw,w->height());
	   		 break;
  	   case hk_kdesimpleform::smaxw :  w->setGeometry(w->x(),w->y(),maxw,w->height());
	   		 break;
  	   case hk_kdesimpleform::sminh :  w->setGeometry(w->x(),w->y(),w->width(),minh);
	   		 break;
  	   case hk_kdesimpleform::smaxh :  w->setGeometry(w->x(),w->y(),w->width(),maxh);
	   		 break;
 	   case hk_kdesimpleform::smins :  w->setGeometry(w->x(),w->y(),minw,minh);
	   		 break;
 	   case hk_kdesimpleform::smaxs :  w->setGeometry(w->x(),w->y(),maxw,maxh);
	   		 break;
 	   case hk_kdesimpleform::al :  w->setGeometry(minx,w->y(),w->width(),w->height());
	   		 break;
 	   case hk_kdesimpleform::ar :  w->setGeometry(maxx-w->width(),w->y(),w->width(),w->height());
	   		 break;
 	   case hk_kdesimpleform::at :  w->setGeometry(w->x(),miny,w->width(),w->height());
	   		 break;
 	   case hk_kdesimpleform::ab :  w->setGeometry(w->x(),maxy-w->height(),w->width(),w->height());
	   		 break;
	   default:;
  	}

}

void hk_kdesimpleform::repaint_focus(void)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::repaint_focus");
#endif
  list<hk_kdeformfocus*>::iterator it=p_multiplefocus.begin();
  while (it!=p_multiplefocus.end())
  {
     hk_kdeformfocus* f=(*it);
     it++;
     f->set_positions();
  }
  p_focus->set_positions();
}

void hk_kdesimpleform::widget_specific_presentationdatasource(long p)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::widget_specific_new_presentationdatasource");
#endif
   if (p_kdeform!=NULL) p_kdeform->set_presentationdatasource(p,false);

}

void hk_kdesimpleform::set_kdeform(hk_kdeform* k)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::set_kdeform");
#endif
   p_kdeform=k;
}

bool hk_kdesimpleform::is_formobject(QWidget* v)
{
#ifdef HK_DEBUG
hkdebug("hk_kdesimpleform::is_formobject");
#endif
QWidget* object =v;

while (object!=NULL)
{
  if (object==this) return true;
  object=object->parentWidget();

}


 return false;
}

