// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************

#ifndef HK_KDESIMPLEFORM_H
#define HK_KDESIMPLEFORM_H
#include "hk_form.h"
#include <qwidget.h>
class hk_kdeformfocus;
class hk_kdeproperty;
class hk_kdeform;
class QPopupMenu;
/**
*
*@short KDE Widget to display forms.
*@version $Revision: 1.9 $
*@author Horst Knorr (hk_classes@knorrnet.de)
*
*hk_kdesimpleform is a KDE widget to display and alter forms.
*Just set the database with @ref hk_presentation::set_database. Load existing  forms
*with @ref hk_form::load_form. If @ref hk_presentation::mode is set to 'view' the data will be shown.
*In mode 'design' you can design your widget.
*For interactive use it is better to use @ref hk_kdeform because it provides toolbars.
*/

class hk_kdesimpleform :public QWidget,public hk_form
{
	Q_OBJECT
	public:
	hk_kdesimpleform(QWidget* wid);
virtual	~hk_kdesimpleform(void);
/**
* if true the widget will be destroyed when the widget will be closed else just hidden
*/
void set_autoclose(bool c){p_autoclose=c;}
	void set_kdeform(hk_kdeform*);
signals:
	void closeform(void);
	void mouseclick(const QPoint&);
	void field_created(void);
	public slots:
	void set_field2create(enum_visibletype);
	const hk_kdeformfocus* formfocus(void){return p_focus;}
	protected:
virtual hk_dsgrid*		widget_specific_new_grid(void);
virtual hk_dsrowselector*	widget_specific_new_rowselector(void);
virtual	hk_dslineedit*	 	widget_specific_new_lineedit(void);
virtual	hk_dsboolean* 		widget_specific_new_bool(void);
virtual	hk_dsmemo* 		widget_specific_new_memo(void);
virtual	hk_button* 		widget_specific_new_button(void);
virtual hk_dscombobox* 		widget_specific_new_combobox(void);
virtual hk_label* 		widget_specific_new_label(void);
virtual void			widget_specific_fieldresize(hk_visible* v);
virtual void			widget_specific_formresize(void);
virtual void 			before_source_vanishes(void);
virtual void 			widget_specific_modechanges(enum_mode);
virtual void 			widget_specific_presentationdatasource(long);
virtual void 	 		paintEvent(QPaintEvent*);
virtual void 			mousePressEvent(QMouseEvent*);
virtual void			mouseReleaseEvent(QMouseEvent*);
virtual void			widget_specific_after_loadform(void);
virtual void 			keyPressEvent ( QKeyEvent * );
virtual void 			keyReleaseEvent ( QKeyEvent * );
virtual void			database_has_vanished(void);
       	bool eventFilter(QObject* object,QEvent* event);
       	bool formeventFilter(QObject* object,QEvent* event);
	private:
	enum enum_adjust {al,ar,at,ab,sminw,smaxw,sminh,smaxh,smaxs,smins};
	bool is_formobject(QWidget*);
	void create_field(const QPoint&);
	void clearmultiplefocus(void);
	void clearfocus(void);
	void set_focus(QWidget*);
	void delete_widgets(void);
	void mousemenu(QMouseEvent*);
	void adjust_widgets(enum_adjust);
	void resize_widget(QWidget*,enum_adjust,int minw,int maxw,int minh,int maxh,int minx,int maxx,int miny,int maxy);
	void repaint_focus(void);
    bool p_autoclose;
    enum_visibletype p_field2create;
    hk_kdeformfocus* p_focus;
    list<hk_kdeformfocus*> p_multiplefocus;
    bool p_createflag;
    QPoint p_originalposition;
    bool p_controlbutton;
    hk_kdeproperty* p_property;
    hk_kdeform* p_kdeform;
    QPopupMenu* p_popup;
};

#endif


