// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.10 $

#include "hk_kdetabledesign.h"
#include "hk_kdetabledesign.moc"
#include "hk_kdeindexeditwindow.h"
#include "hk_database.h"
#include "hk_connection.h"

#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qheader.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qtoolbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qlistbox.h>


/*
 *  Constructs a hk_kdetabledesign which is a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'
 */
hk_kdetabledesign::hk_kdetabledesign( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )  ,hk_dsgrid()
{
#ifdef HK_DEBUG
  hkdebug("hk_kdetabledesign::hk_kdetabledesign");
  hkclassname("hk_kdetabledesign");
#endif
    if ( !name )
	setName( "hk_kdetabledesign" );
    resize( 448, 301 );
    setCaption( hk_translate( "Tabledesign"  ).c_str() );
    hk_kdetabledesignLayout = new QGridLayout( this );
    hk_kdetabledesignLayout->setSpacing( 6 );
    hk_kdetabledesignLayout->setMargin( 11 );


    indexwindow=new QListView(this,"indexwindow");
    indexwindow->addColumn( hk_translate( "Index" ).c_str() );
    indexwindow->addColumn( hk_translate( "Unique" ).c_str() );
    indexwindow->setAllColumnsShowFocus(true);

    fieldlist = new QListView( this, "fieldlist" );
    fieldlist->addColumn( hk_translate( "Name" ).c_str() );
    fieldlist->addColumn( hk_translate( "Type" ).c_str() );
    fieldlist->addColumn( hk_translate( "Size" ).c_str() );
    fieldlist->addColumn( hk_translate( "Primary" ).c_str() );
    fieldlist->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)7, fieldlist->sizePolicy().hasHeightForWidth() ) );
    fieldlist->setMinimumSize( QSize( 200, 0 ) );
    fieldlist->setAllColumnsShowFocus( TRUE );

    hk_kdetabledesignLayout->addMultiCellWidget( fieldlist, 0, 2, 0, 0 );
//    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding );
//    hk_kdetabledesignLayout->addItem( spacer, 1, 1 );

    Layoutindexwindow = new QHBoxLayout;
    Layoutindexwindow->setSpacing( 6 );
    Layoutindexwindow->setMargin( 0 );
    Layoutindexwindow->addWidget(indexwindow);

    buttonlayout = new QVBoxLayout;
    buttonlayout->setSpacing( 6 );
    buttonlayout->setMargin( 0 );

    editlayout = new QVBoxLayout;
    editlayout->setSpacing( 6 );
    editlayout->setMargin( 0 );

    fieldbuttonlayout = new QVBoxLayout;
    fieldbuttonlayout->setSpacing( 6 );
    fieldbuttonlayout->setMargin( 0 );

    fieldtoplayout = new QHBoxLayout;
    fieldtoplayout->setSpacing( 6 );
    fieldtoplayout->setMargin( 0 );
    editlayout->addLayout( fieldtoplayout );
    editlayout->addLayout(Layoutindexwindow);
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    fieldtoplayout->addItem( spacer );
    fieldtoplayout->addLayout( fieldbuttonlayout);

    alterbutton = new QPushButton( this, "alterbutton" );
    alterbutton->setText( hk_translate( "Alter Table"  ).c_str() );
    fieldbuttonlayout->addWidget( alterbutton );

    newbutton = new QPushButton( this, "newbutton" );
    newbutton->setText( hk_translate( "New Field"  ).c_str() );
    fieldbuttonlayout->addWidget( newbutton );

    deletebutton = new QPushButton( this, "deletebutton" );
    deletebutton->setText( hk_translate( "Delete Field"  ).c_str() );
    deletebutton->setEnabled( FALSE );
    fieldbuttonlayout->addWidget( deletebutton );

    QLabel* b = new QLabel(this,"b");
    buttonlayout->addWidget( b );

    indexnewbutton = new QPushButton( this, "indexnewbutton" );
    indexnewbutton->setText( hk_translate( "New Index"  ).c_str() );
    indexnewbutton->setEnabled( true );
    buttonlayout->addWidget( indexnewbutton );

    indexdeletebutton = new QPushButton( this, "indexdeletebutton" );
    indexdeletebutton->setText( hk_translate( "Delete Index"  ).c_str() );
    indexdeletebutton->setEnabled( FALSE );
    buttonlayout->addWidget( indexdeletebutton );

    indexalterbutton = new QPushButton( this, "indexalterbutton" );
    indexalterbutton->setText( hk_translate( "Alter Index"  ).c_str() );
    indexalterbutton->setEnabled( FALSE );
    buttonlayout->addWidget( indexalterbutton );



    Layoutindexwindow->addLayout( buttonlayout );
    hk_kdetabledesignLayout->addLayout( editlayout, 2, 1 );

    Layout8 = new QHBoxLayout;
    Layout8->setSpacing( 6 );
    Layout8->setMargin( 0 );

    Layout7 = new QHBoxLayout;
    Layout7->setSpacing( 6 );
    Layout7->setMargin( 0 );
    QSpacerItem* spacer_3 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout7->addItem( spacer_3 );

    Layout22 = new QVBoxLayout;
    Layout22->setSpacing( 6 );
    Layout22->setMargin( 0 );

    TextLabel1 = new QLabel( this, "TextLabel1" );
    TextLabel1->setText( hk_translate( "Fieldname:"  ).c_str() );
    Layout22->addWidget( TextLabel1 );

    TextLabel2 = new QLabel( this, "TextLabel2" );
    TextLabel2->setText( hk_translate( "Fieldtype:"  ).c_str() );
    TextLabel2->setMinimumSize( QSize( 99, 0 ) );
    Layout22->addWidget( TextLabel2 );

    TextLabel4 = new QLabel( this, "TextLabel4" );
    TextLabel4->setText( hk_translate( "Size:"  ).c_str() );
    Layout22->addWidget( TextLabel4 );

    TextLabel5 = new QLabel( this, "TextLabel5" );
    TextLabel5->setText( hk_translate( "Primary Index"  ).c_str() );
    TextLabel5->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)1, TextLabel5->sizePolicy().hasHeightForWidth() ) );
    TextLabel6 = new QLabel( this, "TextLabel6" );
    TextLabel6->setText( hk_translate( "Not Null"  ).c_str() );
    TextLabel6->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)1, TextLabel6->sizePolicy().hasHeightForWidth() ) );
    Layout22->addWidget( TextLabel5 );
    Layout22->addWidget( TextLabel6 );
    Layout7->addLayout( Layout22 );
    Layout8->addLayout( Layout7 );

    Layout24 = new QVBoxLayout;
    Layout24->setSpacing( 6 );
    Layout24->setMargin( 0 );

    namefield = new QLineEdit( this, "namefield" );
    namefield->setMinimumSize( QSize( 100, 0 ) );
    namefield->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)0, namefield->sizePolicy().hasHeightForWidth() ) );
    namefield->setEnabled(false);
    Layout24->addWidget( namefield );

    typefield = new QComboBox( FALSE, this, "typefield" );
    typefield->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)0, typefield->sizePolicy().hasHeightForWidth() ) );
    typefield->setMinimumSize( QSize( 100, 0 ) );
    typefield->setEnabled(false);
    Layout24->addWidget( typefield );

    sizefield = new QSpinBox( this, "sizefield" );
    sizefield->setMaxValue(65535);
    sizefield->setEnabled(false);
    Layout24->addWidget( sizefield );

    Layout23 = new QHBoxLayout;
    Layout23->setSpacing( 6 );
    Layout23->setMargin( 0 );

    primaryfield = new QCheckBox( this, "primaryfield" );
    primaryfield->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, primaryfield->sizePolicy().hasHeightForWidth() ) );
    primaryfield->setEnabled(false);
    Layout23->addWidget( primaryfield );
    QSpacerItem* spacer_4 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout23->addItem( spacer_4 );
    Layout24->addLayout( Layout23 );

    Layout25 = new QHBoxLayout;
    Layout25->setSpacing( 6 );
    Layout25->setMargin( 0 );
    notnullfield = new QCheckBox( this, "notnullfield" );
    notnullfield->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, notnullfield->sizePolicy().hasHeightForWidth() ) );
    notnullfield->setEnabled(false);
    QSpacerItem* spacer_5 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout25->addWidget( notnullfield );
    Layout25->addItem( spacer_5 );
    Layout24->addLayout( Layout25);
    Layout8->addLayout( Layout24 );

    hk_kdetabledesignLayout->addLayout( Layout8, 0, 1 );
 p_fieldlist_created=false;
 structure_changes(false);
    // signals and slots connections
    connect( namefield, SIGNAL( textChanged(const QString&) ), this, SLOT( name_changed() ) );
    connect( typefield, SIGNAL( activated(const QString&) ), this, SLOT( type_changed() ) );
    connect( sizefield, SIGNAL( valueChanged(const QString&) ), this, SLOT( size_changed() ) );
    connect( fieldlist, SIGNAL( selectionChanged(QListViewItem*) ), this, SLOT( selection_changed() ) );
    connect( primaryfield, SIGNAL( stateChanged(int) ), this, SLOT( primary_changed() ) );
    connect( notnullfield, SIGNAL( stateChanged(int) ), this, SLOT( notnull_changed() ) );
    connect( alterbutton, SIGNAL( clicked() ), this, SLOT( alterbutton_clicked() ) );
    connect( newbutton, SIGNAL( clicked() ), this, SLOT( new_clicked() ) );
    connect( deletebutton, SIGNAL( clicked() ), this, SLOT( delete_clicked() ) );

    connect( indexdeletebutton, SIGNAL( clicked() ), this, SLOT( delete_index() ) );
    connect( indexalterbutton, SIGNAL( clicked() ), this, SLOT( alter_index() ) );
    connect( indexwindow, SIGNAL( doubleClicked(QListViewItem*) ), this, SLOT( alter_index() ) );
    connect( indexnewbutton, SIGNAL( clicked() ), this, SLOT( new_index() ) );
    connect( indexwindow, SIGNAL( selectionChanged(QListViewItem*) ), this, SLOT( indexselection_changed() ) );

  lastmarkedItem=NULL;
  fieldnamecheck=true;
  create_fieldtypelist();
}

/*
 *  Destroys the object and frees any allocated resources
 */
hk_kdetabledesign::~hk_kdetabledesign()
{
     fieldtype_dictionary.erase(fieldtype_dictionary.begin(),fieldtype_dictionary.end());
     fields.erase(fields.begin(),fields.end());
    // no need to delete child widgets, Qt does it all for us
}

void hk_kdetabledesign::create_fieldtypelist(void)
{
     dictclass dict;
     fieldtype_dictionary.erase(fieldtype_dictionary.begin(),fieldtype_dictionary.end());
     typefield->clear();
     QString ftypename;

      ftypename= hk_translate( "Text" ).c_str();
    typefield->insertItem(ftypename  );
     dict.name=ftypename;
     dict.type=hk_column::textfield;
     fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);

      ftypename= hk_translate( "Memo" ).c_str();
    typefield->insertItem(ftypename  );
     dict.name=ftypename.latin1();
     dict.type=hk_column::memofield;
     fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);



      ftypename= hk_translate( "Integer" ).c_str();
    typefield->insertItem(ftypename  );
     dict.name=ftypename;
     dict.type=hk_column::integerfield;
     fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);



      ftypename= hk_translate( "Small Integer" ).c_str();
    typefield->insertItem(ftypename  );
     dict.name=ftypename;
     dict.type=hk_column::smallintegerfield;
     fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);

  if (datasource()!=NULL)
  	if (datasource()->database()->connection()->server_supports()&supports_autoinc)
	 {
      		ftypename= hk_translate( "Auto Increment" ).c_str();
    		typefield->insertItem(ftypename  );
     		dict.name=ftypename;
  		dict.type=hk_column::auto_incfield;
                fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);
	 }



      ftypename= hk_translate( "Float" ).c_str();
    typefield->insertItem(ftypename  );
     dict.name=ftypename;
     dict.type=hk_column::floatingfield;
     fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);



      ftypename= hk_translate( "Small Float" ).c_str();
    typefield->insertItem(ftypename  );
     dict.name=ftypename;
     dict.type=hk_column::smallfloatingfield;
     fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);

 if (datasource()!=NULL)
    if (datasource()->database()->connection()->server_supports()&supports_boolfield)
     {
	ftypename=hk_translate( "Bool" ).c_str();
    	typefield->insertItem( ftypename );
     	dict.name=ftypename;
     	dict.type=hk_column::boolfield;
     	fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);
      }
   	typefield->setSizeLimit(12);


      ftypename= hk_translate( "Date" ).c_str();
    typefield->insertItem(ftypename  );
     dict.name=ftypename;
     dict.type=hk_column::datefield;
     fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);



      ftypename= hk_translate( "Time" ).c_str();
    typefield->insertItem(ftypename  );
     dict.name=ftypename.latin1();
     dict.type=hk_column::timefield;
     fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);



      ftypename= hk_translate( "Datetime" ).c_str();
    typefield->insertItem(ftypename  );
     dict.name=ftypename;
     dict.type=hk_column::datetimefield;
     fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);





      ftypename= hk_translate( "Binary" ).c_str();
    typefield->insertItem(ftypename  );
     dict.name=ftypename;
     dict.type=hk_column::binaryfield;
     fieldtype_dictionary.insert(fieldtype_dictionary.end(),dict);


}

void hk_kdetabledesign::set_datasource(hk_datasource* d)
{
 hk_dsgrid::set_datasource(d);
 create_fieldtypelist();
 set_indexlist();
}

hk_datasource* hk_kdetabledesign::datasource(void)
{
  return hk_dsgrid::datasource();
}



hk_column::enum_fieldtype hk_kdetabledesign::ftype(const QString& f)
{
 list<dictclass>::iterator it=fieldtype_dictionary.begin();

 while (it!=fieldtype_dictionary.end())
 {
  if ((*it).name==f)  return (*it).type;
  it++;
 }
 return hk_column::otherfield;
}

bool hk_kdetabledesign::alter_table()
{
     bool res=true;

 if (p_has_changed )
 {
  if (datasource()==NULL)
  {
     show_warningmessage(hk_translate("No datasource defined!"));
     return true;
  }

  if (!show_yesnodialog(hk_translate("Do you want to alter the table?"),true))
    {
       p_fieldlist_created=false;
       structure_changes(false);
       fieldnamecheck=true;
     lastmarkedItem=NULL;
       return true;
    }

   if (datasource()->name().size()==0)
	{
	   hk_string res=show_stringvaluedialog(hk_translate("Please enter the tablename: "));
           datasource()->set_name(res.c_str());
	}
  if (datasource()->name().size()==0) return false;
  if (datasource()->database()->table_exists(datasource()->name()))
  		datasource()->setmode_altertable();
  else    	datasource()->setmode_createtable();

    list<fieldstruct>::iterator it=fields.begin();
    while (it!=fields.end())
    {
       switch ((*it).state)
      {
       case altered:            {
				 datasource()->alter_column(
				         (*it).oldname,
				 	((*it).oldname!=(*it).newname)?&((*it).newname):NULL,
				 	((*it).oldtype!=(*it).newtype)?&((*it).newtype):NULL,
				 	((*it).oldsize!=(*it).newsize)?&((*it).newsize):NULL,
					 NULL,
				 	((*it).oldprimary!=(*it).newprimary)?&((*it).newprimary):NULL,
				 	((*it).oldnotnull!=(*it).newnotnull)?&((*it).newnotnull):NULL
					);
       				}
       				break
				;
       case delfield:           datasource()->delete_column((*it).oldname);
       				break
				;
       case newfield:           {
       				   hk_column* c=datasource()->new_column();
       				   c->set_name((*it).newname.c_str());
				   c->set_fieldtype((*it).newtype);
				   c->set_size((*it).newsize);
				   c->set_primary((*it).newprimary);
				   c->set_notnull((*it).newnotnull);
				 }
				break
				;


       default:;
      }
     it++;
    }
  if (datasource()->mode()==hk_datasource::mode_altertable) res=datasource()->alter_table_now();
  else
  if (datasource()->mode()==hk_datasource::mode_createtable) res=datasource()->create_table_now();
 }

if (res)
{
     fields.erase(fields.begin(),fields.end());
     lastmarkedItem=NULL;
     p_fieldlist_created=false;
     structure_changes(false);
  }
 else show_warningmessage(hk_translate("Table could not be changed!"));

 return res;
}

void hk_kdetabledesign::alterbutton_clicked()
{
  if (alter_table() )  load_fieldinfo();
}

void hk_kdetabledesign::delete_clicked()
{
    QListViewItem* f=fieldlist->currentItem();

    QListViewItem* p=NULL;
    if (f==NULL)  return;
    f->itemBelow();

   if ((*actualfieldit).state!=newfield)
   {
    (*actualfieldit).state=delfield;
    lastmarkedItem=NULL;
    if (p==NULL) p=f->itemAbove();
   }
   else
   {
     if (actualfieldit!=fields.end())
     {
	fields.erase(actualfieldit);
	actualfieldit=fields.end();
     }

   }

    fieldlist->takeItem(fieldlist->currentItem());
     structure_changes(true);
    if (p!=NULL)
    {
     fieldlist->setCurrentItem(p);
     fieldlist->setSelected(p,true);

    }

}


void hk_kdetabledesign::index_clicked()
{
//  indexwindow->datasource(datasource());
//  indexwindow->show();
}


void hk_kdetabledesign::new_clicked()
{
    QString n;
    QString nn=hk_translate("newfield_").c_str();
    QString num;
    int numint=0;
     do
     {
      num=num.setNum(numint);
      numint++;
      n=nn+num;
     }
     while (fieldname_count(n.latin1())!=0);
    QString t=hk_translate("Text").c_str();
    QListViewItem* feld=new QListViewItem(fieldlist,n,t,"50",hk_translate("no").c_str());
    fieldstruct f;
    f.oldname=f.newname=n;
    f.oldtype=f.newtype=hk_column::textfield;
    f.oldsize=f.newsize=50;
    f.oldprimary=f.newprimary=false;
    f.oldnotnull=f.newnotnull=false;
    f.state=newfield;
    fields.insert(fields.end(),f);
    structure_changes(true);
    fieldlist->setCurrentItem(feld);

}


void hk_kdetabledesign::name_changed()
{
   QListViewItem* i=fieldlist->currentItem();
   if (i==NULL)return;
   (*actualfieldit).newname=namefield->text().latin1();
   if ((*actualfieldit).state!=newfield&&(*actualfieldit).state!=delfield) (*actualfieldit).state=altered;
   i->setText(0,namefield->text());
     structure_changes(true);
}


void hk_kdetabledesign::primary_changed()
{
    QListViewItem* i=fieldlist->currentItem();
    if (i==NULL)return;
    (*actualfieldit).newprimary=primaryfield->isChecked();
    if ((*actualfieldit).state!=newfield&&(*actualfieldit).state!=delfield) (*actualfieldit).state=altered;
    QString a=primaryfield->isChecked()?hk_translate("yes").c_str():hk_translate("no").c_str();
    i->setText(3,a);
     structure_changes(true);
}

void hk_kdetabledesign::notnull_changed()
{

   (*actualfieldit).newnotnull=notnullfield->isChecked();
    if ((*actualfieldit).state!=newfield&&(*actualfieldit).state!=delfield) (*actualfieldit).state=altered;
     structure_changes(true);

}


void hk_kdetabledesign::size_changed()
{
    QListViewItem* i=fieldlist->currentItem();
    if (i==NULL)return;
    (*actualfieldit).newsize=sizefield->value();
    i->setText(2,sizefield->text());
     structure_changes(true);
    if ((*actualfieldit).state!=newfield&&(*actualfieldit).state!=delfield) (*actualfieldit).state=altered;

}

void hk_kdetabledesign::type_changed()
{
    QListViewItem* i=fieldlist->currentItem();
    if (i==NULL)return;
   if ((*actualfieldit).state!=newfield&&(*actualfieldit).state!=delfield) (*actualfieldit).state=altered;
    (*actualfieldit).newtype=ftype(typefield->currentText());
    i->setText(1,typefield->currentText());
     structure_changes(true);
}
int hk_kdetabledesign::fieldname_count(const hk_string& f)
{
 int res=0;
 list<fieldstruct>::iterator it=fields.begin();
 while (it!=fields.end())
 {
  if ((*it).newname==f)res++;

  it++;
 }
 return res;
}

void hk_kdetabledesign::indexselection_changed()
{
      QListViewItem* i=indexwindow->currentItem();
      if (i==NULL)
      {
         indexdeletebutton->setEnabled( FALSE );
         indexalterbutton->setEnabled( FALSE );
         return;
      }
         indexdeletebutton->setEnabled( true );
         indexalterbutton->setEnabled( true );

}
void hk_kdetabledesign::selection_changed()
{
      QListViewItem* i=fieldlist->currentItem();
      if (i==NULL)return;

      if (lastmarkedItem!=NULL)
        {
	  if ((fieldname_count(lastmarkedItem->text(0).latin1())>1||lastmarkedItem->text(0).length()==0)
	      &&fieldnamecheck)
	  {
	   fieldnamecheck=false;
	   show_warningmessage(hk_translate("Fieldname already exists or is of length 0. Alter it to a unique one!"));
	   fieldlist->setCurrentItem(lastmarkedItem);
	   fieldnamecheck=true;
	   return;
	  }


	}
      namefield->blockSignals(true);
      sizefield->blockSignals(true);
      primaryfield->blockSignals(true);
      notnullfield->blockSignals(true);
      typefield->blockSignals(true);

      namefield->setText(i->text(0));
      int v=i->text(2).toInt();
      sizefield->setValue(v);
      primaryfield->setChecked(i->text(3)==(QString) hk_translate("yes").c_str());
      QListBox* l=typefield->listBox();
      if (l!=NULL)
      {
         QListBoxItem* li =l->findItem(i->text(1));
         if (li!=NULL) typefield->setCurrentItem(l->index(li));
      }



      list<fieldstruct>::iterator it=fields.begin();
      bool found=false;
        hk_string nn=i->text(0).latin1();
      while (it!=fields.end()||!found)
      {
       if ((*it).newname==nn)
       {
          actualfieldit=it;
	  found=true;
       }
       it++;
      }

      notnullfield->setChecked((*actualfieldit).newnotnull);

      deletebutton->setEnabled(true);
      namefield->blockSignals(false);
      sizefield->blockSignals(false);
      primaryfield->blockSignals(false);
      notnullfield->blockSignals(false);
      typefield->blockSignals(false);
      lastmarkedItem=fieldlist->currentItem();

}




void hk_kdetabledesign::showEvent(QShowEvent* e)
{
  QWidget::showEvent(e);
  if (!p_fieldlist_created)load_fieldinfo();

}

void hk_kdetabledesign::load_fieldinfo()
{
  #ifdef HK_DEBUG
  hkdebug("hk_kdetabledesign::load_fieldinfo()");
  #endif
  fieldlist->clear();
  fields.erase(fields.begin(),fields.end());
  hk_datasource* d=datasource();
  if (d==NULL) return;
  list<hk_column*>* cols=d->columns();
  if (cols==NULL) return;
  list<hk_column*>::iterator it=cols->begin();
  while (it!=cols->end())
  {
    fieldstruct f;

    QString n=(*it)->name().c_str();
    f.oldname=f.newname=n;
    QString t=(*it)->fieldtype_name().c_str();
    QString s;
    s=s.setNum((*it)->size());
    f.oldsize=f.newsize=(*it)->size();
    f.oldprimary=f.newprimary=(*it)->is_primary();
    f.oldnotnull=f.newnotnull=(*it)->is_notnull();
    QString a=(*it)->is_primary()?hk_translate("yes").c_str():hk_translate("no").c_str();
    QListViewItem* feld=new QListViewItem(fieldlist,n,t,s,a);


    f.state=unchanged;
    fields.insert(fields.end(),f);
   it++;
  }
  p_fieldlist_created=true;
     structure_changes(false);
 fieldlist->setFocus();
 fieldlist->setCurrentItem(fieldlist->firstChild());
 fieldlist->setSelected(fieldlist->firstChild(),true);
 lastmarkedItem=fieldlist->firstChild();
 fieldnamecheck=true;
 set_indexlist();
}



void hk_kdetabledesign::alter_index()
{
  if (datasource()==NULL){ return; }
 list<hk_datasource::indexclass>* ilist =datasource()->indices();
 if (ilist==NULL){return; }
 list<hk_datasource::indexclass>::iterator it=ilist->begin();
 bool found=false;

 while (it!=ilist->end() &&!found)
 {
  hk_string r= indexwindow->currentItem()->text(0).latin1();
  if ((*it).name==r) found=true;
  else  it++;
 }
 if (found)
 {

      hk_kdeindexeditdialog* d = new hk_kdeindexeditdialog(0,0,WDestructiveClose);
      if (d==NULL) return;
      d->set_datasource(datasource());
      if (it!=ilist->end())d->set_indexvalues((*it).name,(*it).unique,(*it).fields,false);
      d->show();
  }
}

void hk_kdetabledesign::delete_index()
{
  if (datasource()==NULL){ return; }
    hk_string r= indexwindow->currentItem()->text(0).latin1();
    datasource()->drop_index(r.c_str());

}

void hk_kdetabledesign::new_index()
{

  if (datasource()==NULL){ return; }

      hk_kdeindexeditdialog* d = new hk_kdeindexeditdialog(0,0,WDestructiveClose);
      if (d==NULL) return;
      d->set_datasource(datasource());
      list<hk_string> f;
      d->set_indexvalues("",false,f,true);
      d->show();
}

void hk_kdetabledesign::set_indexlist(void)
{

  indexwindow->clear();
  hk_datasource* d=datasource();
  if (d==NULL)
  {
  return;
  }
 list<hk_datasource::indexclass>* ilist =d->indices();
 if (ilist==NULL)
 {
   return;
 }
 list<hk_datasource::indexclass>::iterator it=ilist->begin();
 while (it!=ilist->end())
 {
  QListViewItem* feld=new QListViewItem(indexwindow,(*it).name.c_str(),(*it).unique?hk_translate("yes").c_str():hk_translate("no").c_str());
  it++;
 }
 indexwindow->setSelected(indexwindow->firstChild(),true);

}

void hk_kdetabledesign::list_changes(filetype type)
{
  if (type==ft_index) set_indexlist();
}


void hk_kdetabledesign::structure_changes(bool c)
{
 p_has_changed=c;
 alterbutton->setEnabled(c);
 indexnewbutton->setEnabled(!c);
 indexalterbutton->setEnabled(!c);

  bool res;
  if (fieldlist->firstChild()==NULL)
  {
     res=false;
  primaryfield->setChecked(false);
  notnullfield->setChecked(false);
  namefield->setText("");
  }
  else
  {

    res=true;
  }
  namefield->setEnabled(res);
  typefield->setEnabled(res);
  primaryfield->setEnabled(res);
  notnullfield->setEnabled(res);
  sizefield->setEnabled(res);
  deletebutton->setEnabled(res);

}
