// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of knoda -Knorr's Datenbank.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************

#include <hk_classes.h>
#include <kapp.h>
#include <kaboutdata.h>
#include <hk_kdemessages.h>
#include <kcmdlineargs.h>
#include "hk_kdegrid.h"
#include "knodawin.h"
#include "knodaprogram.h"
#include <iostream.h>
#include <klocale.h>
#if HAVE_CONFIG_H
#include <config.h>
#endif
static KCmdLineOptions options[] =
{
    { "d <driver>", I18N_NOOP("Specifies the database driver"), 0 },
    { "runtime", I18N_NOOP("No alter modes"), 0 },
#ifdef HK_DEBUG
    { "debug", I18N_NOOP("debug"), 0 },
#endif
    { 0, 0, 0 }
};




int main(int argc,char** argv)
{
  KAboutData aboutData("knoda", I18N_NOOP("knoda"),
    VERSION, I18N_NOOP("knoda is a relational database management system"), KAboutData::License_GPL,
    "(c) 2001 Horst Knorr",0,"http://knoda.sourceforge.net","hk_classes@knorrnet.de");
  aboutData.addAuthor("Horst Knorr",I18N_NOOP("Author"), "hk_classes@knorrnet.de","http://knoda.sourceforge.net");



   hk_string driver;
   KCmdLineArgs::init(argc,argv,&aboutData);
   KCmdLineArgs::addCmdLineOptions(options);
    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

   KApplication anwendung;
//   driver="mysql";
   if (args->isSet("d"))  driver = args->getOption("d");
#ifdef HK_DEBUG
   if (args->isSet("debug")) hk_class::set_generaldebug(true);
#endif
   set_kdestandarddialogs();
   programwindow* widget=new programwindow(0,0,false,0,driver,args->isSet("runtime"));
   anwendung.setMainWidget( widget);
   widget->show();
   if (driver.size()>0) widget->connect_clicked();
   int i=anwendung.exec();
   delete widget;
   return  i;

}
