// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of knoda -Knorr's Datenbank.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************

#ifndef PROGRAMFORM_H
#define PROGRAMFORM_H

#include <qvariant.h>
#include <qdialog.h>
#include <list>
#include <hk_string.h>
class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QPushButton;
class hk_drivermanager;

class programwindow : public QDialog
{
    Q_OBJECT

public:
    programwindow( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 ,const hk_string& driver="",bool runtime=false);
    ~programwindow();

    QPushButton* connectbutton;
    QPushButton* quitbutton;
    QPushButton* helpbutton;
    QPushButton* optionbutton;
    QPushButton* aboutbutton;

public slots:
    virtual void connect_clicked();
    virtual void help_clicked();
    virtual void option_clicked();
    virtual void quit_clicked();
    virtual void about_clicked();

protected:
    QHBoxLayout* programformLayout;
    QVBoxLayout* Layout2;
private:
   hk_drivermanager* p_drivermanager;
   hk_string p_driver;
   bool p_runtime;
};

#endif // PROGRAMFORM_H
