// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of knoda -Knorr's Datenbank.
// This file may be distributed and/or modified under the terms of the
// GNU General Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************

#ifndef KNODAMAINWINDOW_H
#define KNODAMAINWINDOW_H

#include <qvariant.h>
#include <qwidget.h>
#include <qpopupmenu.h>
#include <hk_classes.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QButtonGroup;
class QLabel;
class hk_listbox;
class QListBoxItem;
class QPushButton;
class QRadioButton;

class knodamainwindow : public QWidget ,public hk_dsvisible
{
    Q_OBJECT

public:
    knodamainwindow( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
virtual    ~knodamainwindow();
    void set_connection(hk_connection* c);
    hk_listbox* itemslist;
    QLabel* TextLabel1;
    QLabel* TextLabel1_2;
    QLabel* databasename;
    QButtonGroup* ButtonGroup2;
    QRadioButton* querybutton;
    QRadioButton* reportbutton;
    QRadioButton* tablebutton;
    QRadioButton* formbutton;
    QRadioButton* databasebutton;
    QButtonGroup* ButtonGroup3;
    QPushButton* newbutton;
    QPushButton* startbutton;
    QPushButton* alterbutton;
    QPushButton* deletebutton;

public slots:
    virtual void alter_clicked();
    virtual void delete_clicked();
    virtual void function_select(int);
    virtual void itemslist_doubleclicked();
    virtual void new_clicked();
    virtual void start_clicked();
    virtual void importcsv_clicked();
    virtual void exportcsv_clicked();
    virtual void itemslist_clicked(QListBoxItem*);

protected:
    QHBoxLayout* knodamainwindowLayout;
    QGridLayout* Layout8;
    QVBoxLayout* Layout3;
    QVBoxLayout* ButtonGroup3Layout;
    QVBoxLayout* ButtonGroup2Layout;
    hk_connection* p_connection;
    hk_database* p_database;
//    hk_classes*  p_class;
virtual void		list_changes(filetype type);
private:
    void set_buttons();
    void set_databasebuttons();
    void set_tablebuttons();
    void set_querybuttons();
    void set_formbuttons();
    void set_reportbuttons();
    void set_minimalbuttons();
    void set_normalbuttons();

    QString p_databasestring;
    QString p_tablestring;
    QString p_querystring;
    QString p_formstring;
    QString p_reportstring;

};

#endif // KNODAMAINWINDOW_H
